package org.netbeans.modules.asm.core.dataobjects;

import java.io.IOException;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.MultiDataObject;
import org.openide.loaders.UniFileLoader;
import org.openide.util.NbBundle;

public class AsmDataLoader extends UniFileLoader {
    
    public static final String REQUIRED_MIME = "text/x-asm";
    
    private static final long serialVersionUID = 1L;
    
    public AsmDataLoader() {
        super("org.netbeans.modules.asm.core.dataobjects.AsmDataObject");
    }
    
    protected String defaultDisplayName() {
        return NbBundle.getMessage(AsmDataLoader.class, "LBL_Asm_loader_name");
    }
    
    protected void initialize() {
        super.initialize();
        getExtensions().addMimeType(REQUIRED_MIME);
    }
    
    protected MultiDataObject createMultiObject(FileObject primaryFile) throws DataObjectExistsException, IOException {
        return new AsmDataObject(primaryFile, this);
    }
    
    protected String actionsContext() {
        return "Loaders/" + REQUIRED_MIME + "/Actions";
    }
    
}
