
package org.netbeans.modules.asm.model;

import java.io.Reader;
import java.util.List;
import org.openide.nodes.Node;

import org.netbeans.modules.asm.model.cpu.OpcodeFactory;
import org.netbeans.modules.asm.model.cpu.StateFactory;
import org.netbeans.modules.asm.model.lang.instruction.Instruction;
import org.netbeans.modules.asm.model.lang.Register;
import org.netbeans.modules.asm.model.AsmModelAccessor;

public interface AsmModel extends Node.Cookie {
    
    List<Instruction> getInstructions();  
    List<Register> getRegisters();   
    
    StateFactory getStateFactory();
    OpcodeFactory getOpcodeFactory();
    
    AsmModelAccessor parse(Reader in);
 }
