/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.test.bpel.diagramelements;


import org.netbeans.jellytools.ProjectsTabOperator;
import org.netbeans.jellytools.nodes.Node;
import org.netbeans.jellytools.nodes.ProjectRootNode;
import org.netbeans.jemmy.EventTool;
import org.netbeans.jemmy.JemmyProperties;
import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JDialogOperator;
import org.netbeans.orchlib.core.operators.MultiviewEditorOperator;
import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.ext.Util;

public class DE_Util {
    
    public DE_Util() {
    }
    
    private static EventTool eventTool = new EventTool();
    
    private static Node getNode(String nodePath, String projectName){
        ProjectsTabOperator pto = ProjectsTabOperator.invoke();
        ProjectRootNode root = new ProjectRootNode(pto.tree(),projectName);
        
        Node node = new Node(root, nodePath);
        return node;
    }
    
    public static void layoutPattern(PatternOperator pattern){
        pattern.getPopup().pushMenuNoBlock("Relayout");
        eventTool.waitNoEvent(1000);
    }
    
    public static MultiviewEditorOperator openProjectBPEL(String projectName, String bpelName){
	try{
            return new MultiviewEditorOperator(bpelName + ".bpel");
	}catch(Exception e){
	    Node node;
	    try{
		node = getNode("Process Files|" + bpelName + ".bpel", projectName);
	    }catch(Exception e1){
		Util.createBPEL(projectName, projectName);
	    }finally{
		node = getNode("Process Files|" + bpelName + ".bpel", projectName);
	    }
//	    node.tree().clickOnPath(node.getTreePath(),2);
	    node.callPopup().pushMenu("Open");
	    eventTool.waitNoEvent(5000);
            return new MultiviewEditorOperator(bpelName + ".bpel");
	}
    }
    
    public static void closeSaveDlg(){
        new Thread(new Runnable() {
            public void run() {
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 10000);
                    JDialogOperator saveDlg = new JDialogOperator("Save");
                    new JButtonOperator(saveDlg, "Save All").pushNoBlock(); 
                }catch(Exception e){}
                finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        }).start();
    } 
    
}