/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * SwitchDnDTests.java
 */

package org.netbeans.test.bpel.dnd;
import org.netbeans.jellytools.JellyTestCase;
import org.netbeans.jemmy.EventTool;
import org.netbeans.junit.NbTestSuite;
import static org.netbeans.test.bpel.dnd.Util.*;
import org.netbeans.jemmy.JemmyProperties;
import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JDialogOperator;
import org.netbeans.orchlib.core.operators.DesignViewOperator;
import org.netbeans.orchlib.core.operators.MultiviewEditorOperator;
import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.core.operators.PatternTypes;

/**
 *
 * @author mikk@netbeans.org
 */
public class IfDnDTests extends JellyTestCase{
    
    private EventTool eventTool = new EventTool();
    
    private PatternTypes patternType = PatternTypes.IF;
    
    public IfDnDTests(String name) {
        super(name);
    }
    
    public static NbTestSuite suite() {
        NbTestSuite suite = new NbTestSuite(IfDnDTests.class);
        return suite;
    }
    
    
    public void testCreateMoveS1(){
        String name = "testCreateMoveS1";
        String projectName = "OrchContainerDnDProject";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqFirst(element, view);
            
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    public void testCreateMoveS2(){
        String name = "testCreateMoveS1PA";
        String projectName = "DnD2";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqMiddle(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    
    public void testCreateMoveS3(){
        String name = "testCreateMoveS3";
        String projectName = "DnD3";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqLast(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    
    public void testCreateMoveSO(){
        String name = "testCreateMoveSO";
        String projectName = "DnD4";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToIfThen(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
            
        }
    }
    
    
    
    
    public void testCreateMoveSC(){
        String name = "testCreateMoveSC";
        String projectName = "DnD5";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToIf(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    public void testCreateMovePM(){
        String name = "testCreateMovePM";
        String projectName = "DnD6";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToPickOnMessage(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    public void testCreateMovePA(){
        String name = "testCreateMovePA";
        String projectName = "DnD7";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToPickOnAlarm(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    public void testCreateMovePAPMSCSOS1S2S3(){
        String name = "testCreateMovePAPMSCSOS1S2S3";
        String projectName = "DnD8";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToPickOnAlarm(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToPickOnMessage(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToIf(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToIfThen(element, view);
            //eventTool.waitNoEvent
            try{
                element = dragPatternToSeqFirst(element, view);
            }catch(Exception e){
                //fail(78468, "Dragging from if-else does not work");
            }
            //eventTool.waitNoEvent
            element = dragPatternToSeqMiddle(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqLast(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
    
    
    public void testCreateMoveS1S2S3SOSCPAPM(){
        String name = "testCreateMoveS1S2S3SOSCPAPM";
        String projectName = "DnD9";
        String bpelFileName = projectName+".bpel";
        try{
            MultiviewEditorOperator editor =  openProjectBPEL(projectName, bpelFileName);
            DesignViewOperator view = editor.getDesignView();
            //eventTool.waitNoEvent
            PatternOperator element = createAndNamePattern(name, patternType, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqFirst(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqMiddle(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToSeqLast(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToIfThen(element, view);
            //eventTool.waitNoEvent
            try{
                element = dragPatternToIf(element, view);
            }catch(Exception e){
                //fail(78468, "Dragging from if-else does not work");
            }            
            //eventTool.waitNoEvent
            element = dragPatternToPickOnAlarm(element, view);
            //eventTool.waitNoEvent
            element = dragPatternToPickOnMessage(element, view);
            
            //eventTool.waitNoEvent
            //new SaveAllAction().performAPI();
            
        }catch(Exception e){
            e.printStackTrace(getLog());
            fail("Unexpected failure detected");
        }
    }
    
   protected void tearDown(){
        ////eventTool.waitNoEvent
        //////new SaveAllAction().performAPI();
        closeSaveDlg();
    }
     
     public void closeSaveDlg(){
        new Thread(new Runnable() {
            public void run() {
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 10000);
                    JDialogOperator saveDlg = new JDialogOperator("Save");
                    new JButtonOperator(saveDlg, "Save All").pushNoBlock();
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        }).start();
    } 
    
    
}
