/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.test.bpel.samples;

import org.apache.tools.ant.module.api.AntProjectCookie;
import org.apache.tools.ant.module.api.AntTargetExecutor;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectManager;
import org.netbeans.api.project.ui.OpenProjects;
import org.netbeans.jellytools.JellyTestCase;
import org.netbeans.jellytools.actions.SaveAllAction;
import org.netbeans.jemmy.EventTool;
import org.netbeans.junit.NbTestSuite;
import org.netbeans.modules.bpel.samples.SynchronousSampleWizardIterator;
import org.openide.execution.ExecutorTask;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileUtil;
import org.openide.filesystems.Repository;
import org.openide.loaders.DataObject;
import org.openide.loaders.TemplateWizard;

import org.netbeans.orchlib.ext.*;
import org.netbeans.test.j2ee.lib.Utils;
import org.netbeans.test.j2ee.lib.ProgressSupport;
import org.netbeans.orchlib.utils.ITitlesAndLabels;

import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JDialogOperator;
import org.netbeans.jemmy.JemmyProperties;

import java.awt.Component;
import java.awt.Container;

import org.netbeans.junit.NbTestCase;

import org.netbeans.jellytools.RuntimeTabOperator;
import org.netbeans.jellytools.ProjectsTabOperator;
import java.io.IOException;
import org.netbeans.jellytools.nodes.Node;
import org.netbeans.jellytools.Bundle;
import org.netbeans.jemmy.operators.JPopupMenuOperator;
import javax.swing.MenuElement;
import javax.swing.JMenuItem;
import javax.swing.tree.TreePath;
import org.netbeans.jemmy.operators.JTreeOperator;
import org.netbeans.jellytools.ProjectsTabOperator;
import org.netbeans.jellytools.OutputTabOperator;
import org.netbeans.jellytools.nodes.ProjectRootNode;
import org.netbeans.jemmy.operators.Operator;
import org.netbeans.jellytools.MainWindowOperator;

import org.netbeans.jemmy.operators.JComponentOperator;
import org.netbeans.jemmy.operators.JTreeOperator;
import org.netbeans.jemmy.operators.JTreeOperator.TreePathChooser;

import org.netbeans.jemmy.ComponentChooser;
import org.netbeans.core.output2.ui.AbstractOutputTab;
import org.netbeans.modules.project.ui.ProjectTab;
import org.openide.windows.TopComponent;
import org.netbeans.modules.junit.output.ResultWindow;

import org.netbeans.jellytools.NbDialogOperator;
import org.netbeans.jemmy.operators.JTextFieldOperator;
import org.netbeans.jemmy.operators.JComboBoxOperator;
import org.netbeans.jemmy.operators.JLabelOperator;

/**
 *
 * @author obarbashov@netbeans.org
 */
public class IncludedSamplesTests extends JellyTestCase{
    
    private static EventTool eventTool = new EventTool();
    
    private static int serverSetted = 0;
    private static int testsNumber = 8;
    
    public IncludedSamplesTests(String name) {
        super(name);
    }
    
    private final String WORK_DIR = System.getProperty("xtest.workdir");
    
    public static NbTestSuite suite() {
        NbTestSuite suite = new NbTestSuite(IncludedSamplesTests.class);
        return suite;
    }
    
    static class FixedUtils extends Utils
    {
        public FixedUtils(NbTestCase nbtestcase) {
            super(nbtestcase);
        }
        
        public static void deploy(String projectName) {
            deploy(projectName, false);
        }
        public static void deploy(String projectName, boolean nameInStatus){
            try {
                deploy(projectName, null, nameInStatus);
            } catch (Exception e) {
                throw new RuntimeException("Exception while deploying project: "+projectName);};
        }
        
         public static void addAppServer() {
            String path = System.getProperty("j2ee.appserver.path");
            if (path == null)
            {
                throw new RuntimeException("Cannot setup appserver, property j2ee.appserver.path is not set. Check '<property name=\"xtest.userdata|j2ee.appserver.path\" value=\"appserver path\"/> in build-qa-functional.xml.");
            }
            String username = System.getProperty("j2ee.appserver.username","admin");
            String password = System.getProperty("j2ee.appserver.password","adminadmin");

            Node node = new Node(new RuntimeTabOperator().getRootNode(),Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.Bundle", "SERVER_REGISTRY_NODE"));
            node.performPopupActionNoBlock(Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.actions.Bundle", "LBL_Add_Server_Instance"));
            NbDialogOperator dialog = new NbDialogOperator(Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.wizard.Bundle", "LBL_ASIW_Title"));
            new JComboBoxOperator(dialog).selectItem("Sun Java System Application Server");
            new JButtonOperator(dialog,Bundle.getStringTrimmed("org.openide.Bundle", "CTL_NEXT")).push();

            //"Enter the Application Server location" or "Define Application Server Instance Properties"
            if (new JLabelOperator(dialog,1).getText().equalsIgnoreCase("Platform Folder Location")) {
                new JTextFieldOperator(dialog).setText("");
                new JTextFieldOperator(dialog).typeText(path);
                new org.netbeans.jemmy.EventTool().waitNoEvent(5000);
                new JButtonOperator(dialog,"Next").push();
            }
            new JTextFieldOperator(dialog,0).setText("");
            new JTextFieldOperator(dialog,1).setText("");
            new JTextFieldOperator(dialog,0).typeText(username);
            new JTextFieldOperator(dialog,1).typeText(password);
            new JButtonOperator(dialog,"Finish").push();
            new ProjectsTabOperator();
        }

        public static void startStopServer(boolean start){
            RuntimeTabOperator runtimeTab = RuntimeTabOperator.invoke();
            Node serverNode = new Node(runtimeTab.getRootNode(), Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.Bundle", "SERVER_REGISTRY_NODE")
            +"|Application Server");
            new org.netbeans.jemmy.EventTool().waitNoEvent(10000);
            serverNode.performPopupAction("Refresh");
            new org.netbeans.jemmy.EventTool().waitNoEvent(10000);
            if (start) {
                JPopupMenuOperator popup = serverNode.callPopup();
                MenuElement[] menuElements = popup.getSubElements();
                String textLabel = "Start";
                JemmyProperties.getCurrentOutput().printLine("Before cycle");
                for (int i = 0; i < menuElements.length; i++) {
                    if (menuElements[i] instanceof JMenuItem) {
                        JemmyProperties.getCurrentOutput().printLine("JMenuItem in " + ((JMenuItem)(menuElements[i])).getText());
                        if (((JMenuItem)(menuElements[i])).getText().compareTo(textLabel) == 0) {
                            JemmyProperties.getCurrentOutput().printLine("getText in");
                            if (((JMenuItem)(menuElements[i])).isEnabled()) {
                                JemmyProperties.getCurrentOutput().printLine("isEnabled in");
                                serverNode.performPopupAction(textLabel);
                                JemmyProperties.getCurrentOutput().printLine("performPopupAction in");
                                new org.netbeans.jemmy.EventTool().waitNoEvent(5000);
                                ProgressSupport.waitFinished((start?"Starting":"Stopping") + " Sun Java System Application Server", 500000);
                                new org.netbeans.jemmy.EventTool().waitNoEvent(2000);
                                break;
                            }
                        }
                        else {
                            JemmyProperties.getCurrentOutput().printLine("Compare failed " + ((JMenuItem)(menuElements[i])).getText() + " " + textLabel);
                        }
                    }
                }
            }
            else {
                serverNode.performPopupAction("Stop");
                new org.netbeans.jemmy.EventTool().waitNoEvent(5000);
                ProgressSupport.waitFinished((start?"Starting":"Stopping") + " Sun Java System Application Server", 500000);
                new org.netbeans.jemmy.EventTool().waitNoEvent(2000);
            }
        }

        public static void startStopEngine(String engine, boolean start) {
            RuntimeTabOperator runtimeTab = RuntimeTabOperator.invoke();
            Node serverNode = new Node(runtimeTab.getRootNode(), Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.Bundle", "SERVER_REGISTRY_NODE")
            +"|Application Server");
            Node jbiNode = new Node(serverNode, "JBI");
            Node serviceEnginesNode = new Node(jbiNode, "Service Engines");
            Node engineNode = new Node(serviceEnginesNode, engine);
            JPopupMenuOperator popup = engineNode.callPopup();
            MenuElement[] menuElements = popup.getSubElements();
            String textLabel = start?"Start":"Stop";
            for (int i = 0; i < menuElements.length; i++) {
                if (menuElements[i] instanceof JMenuItem)
                    if (((JMenuItem)(menuElements[i])).getText().compareTo(textLabel) == 0)
                        if (((JMenuItem)(menuElements[i])).isEnabled()) {
                            engineNode.performPopupAction(textLabel);
                            break;
                        }
            }
        }
        
        public static String deploy(String projectName, String url, boolean projectNameInStatus) throws IOException {
        
            JemmyProperties.getCurrentOutput().printLine("Deploy started");

            JTreeOperator tree = ProjectsTabOperator.invoke().tree();
            tree.setComparator(new Operator.DefaultStringComparator(true, true));
            Node node = new ProjectRootNode(tree, projectName);
            node.performPopupActionNoBlock(Bundle.getStringTrimmed("org.netbeans.modules.j2ee.earproject.ui.Bundle", "LBL_DeployAction_Name"));

            try {
                eventTool.waitNoEvent(2000);
                JDialogOperator selectServerDialog = new JDialogOperator("Warning - Select Server");

                eventTool.waitNoEvent(1000);
                JButtonOperator okButton = new JButtonOperator(selectServerDialog, "OK");

                okButton.pushNoBlock();
            }
            catch (Exception e) {
            };
            
            MainWindowOperator.getDefault().getTimeouts().setTimeout("Waiter.WaitingTime", 60000);
            MainWindowOperator.getDefault().waitStatusText(Bundle.getString("org.apache.tools.ant.module.run.Bundle", "FMT_finished_target_status", new String[] {(projectNameInStatus?projectName:"build.xml")+" (run)"}));
            if (url != null)
                return Utils.loadFromURL(url);
            return null;
        }

        static Node searchNode(Node node, String nodeName) {
            JemmyProperties.getCurrentOutput().printLine("SearchNode is called: " + node.toString());
            String [] childrens = node.getChildren();
            for (int i = 0; i < childrens.length; i++) {
                JemmyProperties.getCurrentOutput().printLine("SearchNode children: " + childrens[i]);
                Node subNode = new Node(node, childrens[i]);
                if (childrens[i].compareTo(nodeName) == 0)
                    return subNode;
                else {
                    Node subNode2 = searchNode(subNode, nodeName);
                    if (subNode2 != null)
                        return subNode2;
                }
            }
            return null;
        }
        
      public static void undeploy(String category, String app) {
            RuntimeTabOperator runtimeTab = RuntimeTabOperator.invoke();
            Node rootNode = new Node(runtimeTab.getRootNode(), Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.Bundle", "SERVER_REGISTRY_NODE")
            +"|Application Server|" + category);
            rootNode.performPopupAction("Refresh");
            Node node = new Node(rootNode, app);
            node.performPopupAction(Bundle.getStringTrimmed("org.netbeans.modules.j2ee.sun.ide.j2ee.runtime.nodes.Bundle", "LBL_Undeploy"));
            node.waitNotPresent();
        }

        public static void recurseComponent(int level, Component component) {
            JemmyProperties.getCurrentOutput().print("*");

            for (int j = 0; j < level; j++) {
                JemmyProperties.getCurrentOutput().print("|");
            }
            JemmyProperties.getCurrentOutput().print("[" + level + "]");

            JemmyProperties.getCurrentOutput().printLine("Name: " + component.getName() + ", Class: " + component.getClass());
            
            if (component instanceof ProjectTab) {
                ProjectTab pt = (ProjectTab)component;
            }

            if (component instanceof Container) {
                Component[] comps = ((Container)component).getComponents();
                for (int i = 0; i < comps.length; i++) {
                    recurseComponent(level+1, comps[i]);
                }
            }
        }

       public static void runTestCase(String projectName, String testCaseName) {
            ProjectsTabOperator projectsTab = ProjectsTabOperator.invoke();
            Node projectNode = projectsTab.getProjectRootNode(projectName);
            Node testRootNode = new Node(projectNode, "Test");
            Node testNode = new Node(testRootNode, testCaseName);
            testNode.performPopupAction("Run");

            eventTool.waitNoEvent(5000);

            JComponentOperator resultsOperator = new JComponentOperator(MainWindowOperator.getDefault(), new JUnitResultsComponentChooser());
            JTreeOperator resultsTree = new JTreeOperator(resultsOperator);

            boolean passed = false;
            for (int i = 0; i < 10; i++) {
                TreePath treePath = resultsTree.getPathForRow(0);
                JemmyProperties.getCurrentOutput().printLine("Try: " + i + " Path: " + treePath.toString());
                if (treePath.toString().contains("passed")) {
                    passed = true;
                    break;
                }
                eventTool.waitNoEvent(1000);
            }
            if (!passed)
                throw new RuntimeException("Test for project " + projectName + " and test case " + testCaseName + " is failed.");
        }
    }
    public void testSynchronousBPELProcessSample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_SYNCH_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_SYNCH_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_SYNCH_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_SYNCH_SAMPLE_NAME + "Application", "TestCase0");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_SYNCH_SAMPLE_NAME + "Application");
    }        
    public void testAsynchronousBPELProcessSample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_ASYNCH_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_ASYNCH_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_ASYNCH_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_ASYNCH_SAMPLE_NAME + "Application", "TestCase0");
    }   
    public void testTravelReservationSample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application");
        FixedUtils.deploy("ReservationPartnerServices", true);
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application", "HasAirline");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application", "HasHotel");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application", "HasNoReservations");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application", "HasVehicle");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_TRS_SAMPLE_NAME + "Application");
        FixedUtils.undeploy("Applications|EJB Modules", "ReservationPartnerServices");
    }
    
    public void testBluePrint1Sample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT1_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT1_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT1_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT1_SAMPLE_NAME + "Application", "testSynchronousInvocation");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_BLUEPRINT1_SAMPLE_NAME + "Application");
    }
    
    public void testBluePrint2Sample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME + "Application", "testAsynchronousInvocation");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME + "Application", "testAsynchronousReplyingFault");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_BLUEPRINT2_SAMPLE_NAME + "Application");
    }
    
    public void testBluePrint3Sample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME + "Application", "inventoryserviceFault");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME + "Application", "poserviceFault");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME + "Application", "sunnyDay");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_BLUEPRINT3_SAMPLE_NAME + "Application");
    }
    
    public void testBluePrint4Sample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME + "Application", "poRequestCancel");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME + "Application", "poRequestConfirm");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_BLUEPRINT4_SAMPLE_NAME + "Application");
    }
    
    public void testBluePrint5Sample() {
        Util.createSampleProject(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT_SAMPLES_SOA_CATEGORY, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME, ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME, WORK_DIR);
        FixedUtils.deploy(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME + "Application");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME + "Application", "reserveAirline");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME + "Application", "reserveAll");
        FixedUtils.runTestCase(ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME + "Application", "reserveOnlyHotel");
        FixedUtils.undeploy("JBI|Service Assemblies", ITitlesAndLabels.ORCH_PRJ_BLUEPRINT5_SAMPLE_NAME + "Application");
    }
    
    protected void setUp() {
        if (serverSetted == 0)
        {
            RuntimeTabOperator runtimeTab = RuntimeTabOperator.invoke();
            Node rootNode = null;
            try {
                rootNode = new Node(runtimeTab.getRootNode(), Bundle.getStringTrimmed("org.netbeans.modules.j2ee.deployment.impl.ui.Bundle", "SERVER_REGISTRY_NODE")
                                         +"|Application Server");
            }
            catch (Exception e) {
                JemmyProperties.getCurrentOutput().printLine("Before FixedUtils.addAppServer();");
                FixedUtils.addAppServer();
            }

            FixedUtils.startStopServer(true);
            FixedUtils.startStopEngine("sun-bpel-engine", true);
        }
        serverSetted++;
        JemmyProperties.getCurrentOutput().printLine("serverSetted: " + serverSetted);
    }
    
    protected void tearDown() {
        eventTool.waitNoEvent(1000);
        new SaveAllAction().performAPI();
        if (serverSetted == testsNumber)
            FixedUtils.startStopServer(false);
    }
    
    public static class TreePathChooserByLastNode implements TreePathChooser {
        private String name;
        private Operator.StringComparator comparator;
        
        public TreePathChooserByLastNode(String name) {
            this.name = name;
        }

        public boolean checkPath(javax.swing.tree.TreePath path, int indexInParent) {
            JemmyProperties.getCurrentOutput().printLine("checkPath: " + path.toString());
            return path.toString().contains(name);
        }
        
        public boolean hasAsParent(javax.swing.tree.TreePath path, int indexInParent) {
            JemmyProperties.getCurrentOutput().printLine("hasAsParent: " + path.toString());
            Object[] comps = path.getPath();
            Object node;
	    for (int i = 1; i < comps.length; i++)
                if (comps.toString().contains(name))
                    return true;
            return false;
        }
        
        public String getDescription() {
            return("Tree path having \"" + name + "\" node.");
       }
    }
    
    public static class JUnitResultsComponentChooser implements ComponentChooser {
        private String name;
        private Operator.StringComparator comparator;

        public JUnitResultsComponentChooser(String name, Operator.StringComparator comparator) {
            this.name = name;
            this.comparator = comparator;
        }

        public JUnitResultsComponentChooser(String name) {
            this(name, new Operator.DefaultStringComparator(true, true));
        }

        public JUnitResultsComponentChooser() {
            this("ResultWindow");
        }

        public boolean checkComponent(Component component) {
            if (component instanceof ResultWindow)
                if (comparator.equals(component.getName(), "junit-test-results"))
                        return true;    
            return false;
        }

        public String getDescription() {
            return("Component having \"" + name + "\" name.");
       }
    }
}