/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


/*
 * ElementTypes.java
 *
 */

package org.netbeans.orchlib.core.operators;

/**
 * This enumeration lists some of the visual elements that are present on the diagram
 * User currently can not operate with these elements (user interacts with Patterns only) but
 * They ar used to find connections and to work with placeholders
 * @author Mikhail.Kondratyev@sun.com
 */
public enum ElementTypes {
    /* This means ANY Element */
    ANY("Any"),
    START_EVENT("org.netbeans.modules.bpel.design.model.elements.StartEvent"),
    END_EVENT("org.netbeans.modules.bpel.design.model.elements.EndEvent"),
    //this is a generic element used for many visual elements. Guys promised to create separate classes later
    //unfortunately currently Task Element can represent quite different objects
    TASK_ELEMENT("org.netbeans.modules.bpel.design.model.elements.TaskElement"),
    EMPTY_ELEMENT("org.netbeans.modules.bpel.design.model.elements.EmptyElement"),
    CONTENT_ELEMENT("org.netbeans.modules.bpel.design.model.elements.ContentElement"),
    PICK("org.netbeans.modules.bpel.design.model.elements.EventGateway"),
    TIMER_EVENT("org.netbeans.modules.bpel.design.model.elements.TimerEvent"),
    PLACEHOLDER_ELEMENT("org.netbeans.modules.bpel.design.model.elements.PlaceHolderElement"),
    MESSAGE_EVENT("org.netbeans.modules.bpel.design.model.elements.MessageEvent"),
    //an invisible element we have to use sometimes
    STUB_ELEMENT("org.netbeans.modules.bpel.design.model.elements.StubElement");
        
    private String val = "";
    
    private ElementTypes(String val){
        this.val = val;
    }
    
    public String toString(){
        return val;
    }
}