/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * Util.java
 */

package org.netbeans.orchlib.ext;

import java.awt.Component;
import java.awt.Container;
import java.awt.Point;
import java.util.LinkedList;
import javax.swing.table.TableModel;
import org.netbeans.orchlib.ext.operators.OrchNewBpelStepOperator;
import org.netbeans.orchlib.ext.operators.OrchProjectLocationNameStepOperator;
import org.netbeans.orchlib.utils.ITitlesAndLabels;
import org.netbeans.jellytools.NewFileWizardOperator;
import org.netbeans.jellytools.NewProjectWizardOperator;
import org.netbeans.jellytools.ProjectsTabOperator;
import org.netbeans.jellytools.MainWindowOperator;
import org.netbeans.jellytools.TopComponentOperator;
import org.netbeans.jellytools.actions.Action;
import org.netbeans.jellytools.nodes.ProjectRootNode;
import org.netbeans.jellytools.properties.Property;
import org.netbeans.jemmy.EventTool;
import org.netbeans.jemmy.JemmyProperties;
import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JDialogOperator;
import org.netbeans.jemmy.operators.JListOperator;
import org.netbeans.jemmy.operators.JPopupMenuOperator;
import org.netbeans.jemmy.operators.JTextComponentOperator;
import org.netbeans.jellytools.properties.PropertySheetOperator;
import org.netbeans.jemmy.operators.JComboBoxOperator;
import org.netbeans.jemmy.operators.JTableOperator;
import org.netbeans.core.windows.view.ui.tabcontrol.TabbedAdapter;
import org.netbeans.jemmy.util.Dumper;


/**
 * Some utility methods used in tests and in lib
 * @author Mikhail.Kondratyev@sun.com
 */
public class Util {
    
    public Util() {
    }
    
    private static EventTool eventTool = new EventTool();
    
    public static void createSampleProject(String cathegory, String sampleName, String pName, String path){
        eventTool.waitNoEvent(2000);
        NewProjectWizardOperator wiz = NewProjectWizardOperator.invoke();
        eventTool.waitNoEvent(2000);
        wiz.selectCategory(cathegory);
        
        NewProjectWizardOperator.DefaultStringComparator comparator = new NewProjectWizardOperator.DefaultStringComparator(true, true);
        NewProjectWizardOperator.StringComparator oldComparator = wiz.getComparator();
        wiz.setComparator(comparator);
        
        wiz.selectProject(sampleName);
        
        wiz.setComparator(oldComparator);
        
        wiz.next();
        
        eventTool.waitNoEvent(1000);
        OrchProjectLocationNameStepOperator orchProjectName = new OrchProjectLocationNameStepOperator("New Project");
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName = orchProjectName.txtProjectName();
        txtName.setText(pName);
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtLocation = orchProjectName.txtProjectLocation();
        txtLocation.setText(path);
        
        eventTool.waitNoEvent(500);
        orchProjectName.btnFinish().push();
    }
    public static void createOrchestrationProject(String pName, String path){
        eventTool.waitNoEvent(2000);
        NewProjectWizardOperator wiz = NewProjectWizardOperator.invoke();
        eventTool.waitNoEvent(2000);
        wiz.selectCategory(ITitlesAndLabels.ORCH_SOA_CATEGORY);
        wiz.selectProject(ITitlesAndLabels.ORCH_PRJ_MODULE_NAME);
        wiz.next();
        
        eventTool.waitNoEvent(1000);
        OrchProjectLocationNameStepOperator orchProjectName = new OrchProjectLocationNameStepOperator();
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName = orchProjectName.txtProjectName();
        txtName.setText(pName);
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtLocation = orchProjectName.txtProjectLocation();
        txtLocation.setText(path);
        
        eventTool.waitNoEvent(500);
        orchProjectName.btnFinish().push();
    }
    
    public static void createOrchestrationProject(String pName, String path, String bpelName, String wsdlName){
        NewProjectWizardOperator wiz = NewProjectWizardOperator.invoke();
        eventTool.waitNoEvent(500);
        wiz.selectCategory(ITitlesAndLabels.ORCH_SOA_CATEGORY);
        wiz.selectProject(ITitlesAndLabels.ORCH_PRJ_MODULE_NAME);
        wiz.next();
        
        eventTool.waitNoEvent(1000);
        OrchProjectLocationNameStepOperator orchProjectName = new OrchProjectLocationNameStepOperator();
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName = orchProjectName.txtProjectName();
        txtName.setText(pName);
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtLocation = orchProjectName.txtProjectLocation();
        txtLocation.setText(path);
        
        eventTool.waitNoEvent(500);
        orchProjectName.btnFinish().push();
        
        createBPEL(pName, bpelName);
//        createWSDL(pName, wsdlName);
    }
    
    public static void createBPEL(String prName, String bpelName){
        ProjectsTabOperator pto = ProjectsTabOperator.invoke();
        ProjectRootNode root = new ProjectRootNode(pto.tree(),prName);
        root.select();
        eventTool.waitNoEvent(500);
        
        NewFileWizardOperator wiz = NewFileWizardOperator.invoke();
        eventTool.waitNoEvent(500);
        wiz.selectCategory(ITitlesAndLabels.ORCH_PRJ_CATEGORY);
        wiz.selectFileType(ITitlesAndLabels.ORCH_BPEL_PROCESS_NAME);
        wiz.next();
        
        OrchNewBpelStepOperator orchFileName = new OrchNewBpelStepOperator();
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName1 = orchFileName.txtBpelName();
        txtName1.setText(bpelName);
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName2 = orchFileName.txtFolderName();
        txtName2.setText("src");
        
        eventTool.waitNoEvent(500);
        orchFileName.btnFinish().push();
    }
    
    public static void createWSDL(String prName, String wsdlName){
        ProjectsTabOperator pto = ProjectsTabOperator.invoke();
        ProjectRootNode root = new ProjectRootNode(pto.tree(),prName);
        root.select();
        eventTool.waitNoEvent(500);
        
        NewFileWizardOperator wiz = NewFileWizardOperator.invoke();
        eventTool.waitNoEvent(500);
        wiz.selectCategory(ITitlesAndLabels.ORCH_PRJ_CATEGORY);
        wiz.selectFileType(ITitlesAndLabels.ORCH_WSDL_FILE_NAME);
        wiz.next();
        
        OrchNewBpelStepOperator orchFileName = new OrchNewBpelStepOperator();
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName1 = orchFileName.txtBpelName();
        txtName1.setText(wsdlName);
        
        eventTool.waitNoEvent(500);
        JTextComponentOperator txtName2 = orchFileName.txtFolderName();
        txtName2.setText("src");
        
        eventTool.waitNoEvent(500);
        orchFileName.btnFinish().push();
    }
    
    public static void closeSaveDlg(){
        new Thread(new Runnable() {
            public void run() {
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
                    Thread.sleep(3000);
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 10000);
                    JDialogOperator saveDlg = new JDialogOperator("Save");
                    new JButtonOperator(saveDlg, "Save All").pushNoBlock();
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        }).start();
    }
    
    public static void closePropertyEditor(){
        new Thread(new Runnable() {
            public void run() {
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
                    Thread.sleep(3000);
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 10000);
                    JDialogOperator editor = new JDialogOperator("Property Editor");
                    new JButtonOperator(editor, "Cancel").pushNoBlock();
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        }).start();
    }
    
    public static void closePropertyEditor(final String... fields){
        new Thread(new Runnable() {
            public void run() {
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
                    Thread.sleep(3000);
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 10000);
                    JDialogOperator editor = new JDialogOperator("Property Editor");
                    //fill fields
                    for(int i=0; i<fields.length; i++){
                        //find field
                        JComboBoxOperator field = new JComboBoxOperator(editor, i);
                        //set value
                        field.pushComboButton();
                        field.selectItem(fields[i]);
                    }
                    new JButtonOperator(editor, "OK").pushNoBlock();
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        }).start();
    }
    
    static boolean _bres = false;
    public static boolean closeException(){
        Thread closer = new Thread(new Runnable() {
            public void run() {
                _bres = false;
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
//                    Thread.sleep(1000);
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 1000);
                    JDialogOperator editor = new JDialogOperator("Exception");
                    new JButtonOperator(editor, "OK").pushNoBlock();
                    _bres = true;
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        });
        closer.start();
        try{
            closer.join();
        }catch(InterruptedException e){}
        return _bres;
    }
    
    public static boolean closePopup(final String btnToPress){
        Thread closer = new Thread(new Runnable() {
            public void run() {
                _bres = false;
                long timeoutValDlg = JemmyProperties.getCurrentTimeout("DialogWaiter.WaitDialogTimeout");
                try{
//                    Thread.sleep(1000);
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", 1000);
                    JDialogOperator dlg = new JDialogOperator();
                    new JButtonOperator(dlg, btnToPress).pushNoBlock();
                    _bres = true;
                }catch(Exception e){} finally{
                    JemmyProperties.setCurrentTimeout("DialogWaiter.WaitDialogTimeout", timeoutValDlg);
                }
            }
        });
        closer.start();
        try{
            closer.join();
        }catch(InterruptedException e){}
        return _bres;
    }
    
    
    
    public static boolean checkBuild(String projectName, String target){
        do{
            eventTool.waitNoEvent(500);
        } while(MainWindowOperator.getDefault().getStatusText().equals("Building " + projectName + " (" + target + ")..."));
        String status = MainWindowOperator.getDefault().getStatusText();
        if (status.equals("Finished building " + projectName + " (" + target + ").")){
            return true;
        }else if (status.equals("Build of " + projectName + " (" + target + ") failed.")){
            log("Build failed: " + status);
            return false;
        }else{
            log("Unexpected result of run: " + status);
            return false;
        }
    }
    
    public static void runTarget(String target){
        new Action(ITitlesAndLabels.MAIN_MENU_WINDOW_NAVIGATOR, null).performMenu();
        TopComponentOperator tco_nav = new TopComponentOperator(MainWindowOperator.getDefault(), ITitlesAndLabels.TAB_TITLE_NAVIGATOR);
        JListOperator list_nav = new JListOperator(tco_nav);
        list_nav.selectItem(target);
        Point p = list_nav.getClickPoint(list_nav.getSelectedIndex());
        list_nav.clickForPopup(p.x, p.y);
        eventTool.waitNoEvent(500);
        new JPopupMenuOperator().pushMenuNoBlock(ITitlesAndLabels.POPUP_RUN_TARGET);
    }
    
    public static void log(String text){
        JemmyProperties.getCurrentOutput().printLine(text);
    }
    
    public static Object getNodePropertyValue(Object property){
        Object value = null;
        try{
            value = ((org.openide.nodes.Node.Property)property).getValue();
        }catch(Exception e){
            log("Exception while obtaining org.openide.nodes.Node.Property: "+e.toString());
        }
        return value;
    }
    
//    public static String getPropertyDisplayName(Object property){
//        String displayName = null;
//        try{
//            displayName = ((org.openide.nodes.Node.Property)property).getDisplayName();
//        }catch(Exception e){
//            log("Exception while obtaining org.openide.nodes.Node.Property: "+e.toString());
//        }
//        return displayName;
//    }
    
    public static Property[] getProperties(PropertySheetOperator pso){
        LinkedList<Property> propList = new LinkedList<Property>();
        long waitPropertyTime = JemmyProperties.getCurrentTimeout("Waiter.WaitingTime");
        JemmyProperties.setCurrentTimeout("Waiter.WaitingTime", 2000);
        try{
            JTableOperator table = pso.tblSheet();
            TableModel model = table.getModel();
            int rows = model.getRowCount();
            for(int i=0; i<rows; i++){
                try{
                    Property prop = new Property(pso, i);
                    pso.getOutput().printLine("====="+prop.getName()+" = "+prop.getValue());
                    propList.add(prop);
                }catch(Exception e){}
            }
        }catch(Exception e){
            pso.getOutput().printStackTrace(e);
        } finally{
            JemmyProperties.setCurrentTimeout("Waiter.WaitingTime", waitPropertyTime);
        }
        Property[] props = new Property[propList.size()];
        return propList.toArray(props);
    }
    
    public static void pushToolbarButton(String toolbarName, String buttonName){
        MainWindowOperator window = MainWindowOperator.getDefault();
//        ContainerOperator toolbar = window.getToolbar(toolbarName);
        window.getToolbarButton(window.getToolbar(toolbarName), buttonName).pushNoBlock();
    }
    
    public static TopComponentOperator selectDebugWindow(String windowName){
        TopComponentOperator tco = new TopComponentOperator(windowName);
        Container tabContainer = tco.getSource().getParent().getParent();
        if(tabContainer instanceof TabbedAdapter){
            TabbedAdapter adapter = (TabbedAdapter)tabContainer;
            adapter.setSelectedComponent(tco.getSource());
        }
        return tco;
    }
    
    public static Thread startQuestionCloser(){
        //close warning windows
        final String title = "Question";
        final String button = "Discard";
        Thread closer = new Thread(new Runnable(){
            public void run(){
                for(;;){
                    if(JDialogOperator.findJDialog(title, false, true) != null){
                        new JButtonOperator(new JDialogOperator(title), button ).pushNoBlock();
                    }
                    try{
                        Thread.sleep(100);
                    }catch(InterruptedException e){
                        break;
                    }
                }
            }
        });
        closer.start();
        return closer;
    }
    
    public static void stopQuestionCloser(Thread closer){
        if(closer != null){
            closer.interrupt();
            closer = null;
        }
    }
    
    public static void dumpComponent(Component comp,  String filename){
        
        try{
            Dumper.dumpComponent(comp, filename);
        }catch(Exception e){
            log(e.toString());
        }
    }
    public static void waitFor(long waitTime) {
        try{
            Thread.sleep(waitTime);
        }catch(InterruptedException e){}
    }
}
