/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * Util.java
 *
 */

package org.netbeans.orchlib.ext.creator.actions;


import java.util.Hashtable;
import org.netbeans.orchlib.core.operators.PatternTypes;
import org.w3c.dom.Element;

/**
 * Maps pattern types and corresponding BPEL tags
 * @author Mikhail.Kondratyev@sun.com
 */
public class CreatorUtil {
    
    /** Creates a new instance of Util */
    
    private Hashtable<String, PatternTypes> tagNames = new Hashtable<String, PatternTypes>();
    private Hashtable<String, String> ignoredTags = new Hashtable<String, String>();
    
    public CreatorUtil() {
        tagNames.put("process", PatternTypes.PROCESS);
        tagNames.put("sequence", PatternTypes.SEQUENCE);        
        tagNames.put("receive", PatternTypes.RECEIVE);
        tagNames.put("assign", PatternTypes.ASSIGN);
        tagNames.put("switch", PatternTypes.SWITCH);
        tagNames.put("case", PatternTypes.SWITCH_CASE);
        tagNames.put("invoke", PatternTypes.INVOKE);
        tagNames.put("reply", PatternTypes.REPLY);
        tagNames.put("pick", PatternTypes.PICK);
        tagNames.put("empty", PatternTypes.EMPTY);
        tagNames.put("flow", PatternTypes.FLOW);
        tagNames.put("scope", PatternTypes.SCOPE);
        tagNames.put("while", PatternTypes.WHILE);
        tagNames.put("wait", PatternTypes.WAIT);
        tagNames.put("throw", PatternTypes.THROW);
        tagNames.put("terminate", PatternTypes.EXIT);
        tagNames.put("onAlarm", PatternTypes.ON_ALARM);
        tagNames.put("onMessage", PatternTypes.ON_MESSAGE);        
        tagNames.put("faultHandlers", PatternTypes.FAULT_HANDLER);
        tagNames.put("compensationHandler", PatternTypes.COMPENSATION_HANDLER);
        tagNames.put("eventHandlers", PatternTypes.EVENT_HANDLER);
        tagNames.put("catch", PatternTypes.CATCH);
        tagNames.put("catchAll", PatternTypes.CATCH_ALL);
        tagNames.put("compensate", PatternTypes.COMPENSATE); 
        tagNames.put("elseif", PatternTypes.ELSEIF);
        tagNames.put("if", PatternTypes.IF);
        tagNames.put("else", PatternTypes.IF_ELSE);
    }
        
    public PatternTypes getPatternTypeByTag(String tag){
        return tagNames.get(tag);
    }
    
    public boolean isIgnoredElement(Element element){
        return ignoredTags.containsKey(element.getTagName());
    }
    
    
}
