/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * FaultHandlerCatchAllCreateAction.java
 *
 */

package org.netbeans.orchlib.ext.creator.actions;

import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.core.operators.PatternTypes;
import org.netbeans.orchlib.exceptions.ElementNotFoundException;
import org.netbeans.orchlib.ext.creator.exceptions.CreationVerificationException;
import org.netbeans.jemmy.EventTool;

/**
 *
 * @author Mikhail.Kondratyev@sun.com
 */
public class FaultHandlerCatchAllCreateAction extends CreateAction{
    
    /** Creates a new instance of FaultHandlerCatchAllCreateAction */
    public FaultHandlerCatchAllCreateAction() {
    }
    
    private EventTool eventTool = new EventTool();
    
    public PatternOperator perform(PatternOperator pattern, PatternTypes type) throws ElementNotFoundException, CreationVerificationException{        
        int countTypeBefore = pattern.getChildPatternsCount(PatternTypes.CATCH_ALL);
        pattern.getPopup().pushMenuNoBlock("Add Catch All");
        eventTool.waitNoEvent(1000);
        
        //verification        
        int countTypeAfter = pattern.getChildPatternsCount(PatternTypes.CATCH_ALL);
        if ((countTypeAfter-countTypeBefore)!=1){        
            throw new CreationVerificationException("No Catch All was added to EventHandler"+countTypeBefore);
        }
        return pattern.getDirectChildPattern(PatternTypes.CATCH_ALL, countTypeAfter-1);        
    }
    
}
