/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * IfElseIfCreateAction.java
 * 
 */

package org.netbeans.orchlib.ext.creator.actions;

import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.core.operators.PatternTypes;
import org.netbeans.orchlib.exceptions.ElementNotFoundException;
import org.netbeans.orchlib.ext.creator.exceptions.CreationVerificationException;
import org.netbeans.jemmy.EventTool;

/**
 *
 * @author Mikhail.Kondratyev@sun.com
 */
public class IfElseIfCreateAction extends CreateAction{
    
    /** Creates a new instance of SequenceCreateAction */
    public IfElseIfCreateAction() {
    }
    
    private EventTool eventTool = new EventTool();
    
    public PatternOperator perform(PatternOperator pattern, PatternTypes type) throws ElementNotFoundException, CreationVerificationException{
        int count = pattern.getChildPatternsCount();
        
        //to create new elseif we just call a context menu and then verify new elseif was created
        boolean hasEmptyCase = false;
        int initialElseIfPatternCount = pattern.getChildPatternsCount(PatternTypes.ELSEIF);
        pattern.select();
        eventTool.waitNoEvent(1000);
        pattern.getPopup().pushMenuNoBlock("Add Else If");
        eventTool.waitNoEvent(1000);
        
        //verification
        int elseIfPatternsCount = pattern.getChildPatternsCount(PatternTypes.ELSEIF);
        if (elseIfPatternsCount-initialElseIfPatternCount!=1){
            throw new CreationVerificationException("Failed to add new elseif to if called "+pattern.getName());
        }
        return pattern.getDirectChildPattern(PatternTypes.ELSEIF, elseIfPatternsCount-1);       
        
    }
}
