/*
 * TimeoutNode.java
 * 
 * Created on Jun 18, 2007, 5:45:37 PM
 * 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.modules.worklist.editor.view.nodes;

import org.netbeans.modules.wlm.model.api.TTimeout;
import org.netbeans.modules.worklist.dataloader.WorklistDataObject;
import org.netbeans.modules.worklist.node.cookie.WLMComponentCookie;
import org.netbeans.modules.xml.multiview.ui.SectionView;
import org.openide.util.HelpCtx;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;

/**
 *
 * @author radval
 */
public class TimeoutNode extends org.openide.nodes.AbstractNode {
        
        private static final String HELP_ID_PREFIX=WorklistDataObject.HELP_ID_PREFIX_ASSIGNMENT;
    
        private SectionView view;
        private TTimeout timeout;
        private InstanceContent mLookupContents = new InstanceContent();
    
     
        public TimeoutNode(SectionView view, TTimeout timeout, String displayName) {
            this(view, timeout, displayName, new InstanceContent());
        }
    
        public TimeoutNode(SectionView view, 
                           TTimeout timeout, 
                           String displayName,
                           InstanceContent contents) {
            super(org.openide.nodes.Children.LEAF, new AbstractLookup(contents));
            this.view=view;
            this.timeout = timeout;
            this.mLookupContents = contents;
            setDisplayName(displayName);
            this.mLookupContents.add(new WLMComponentCookie(timeout));  
            
            setIconBaseWithExtension("org/netbeans/modules/worklist/dataloader/wait.gif"); //NOI18N
        }
        public HelpCtx getHelpCtx() {
            return new HelpCtx(HELP_ID_PREFIX+"servletNode"); //NOI18N
        }
    }
