/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.wlm.model.spi;

import org.netbeans.modules.wlm.model.api.TTask;
import org.netbeans.modules.xml.wsdl.model.extensions.bpel.PartnerLinkType;
import org.netbeans.modules.xml.wsdl.model.extensions.bpel.Role;
import org.netbeans.modules.xml.xam.dom.AbstractDocumentComponent;

public class RoleReference extends WSDLReferenceImpl<Role> {

	public RoleReference(AbstractDocumentComponent parent, String ref) {
		super(Role.class, parent, ref);
		// TODO Auto-generated constructor stub
	}

	public RoleReference(Role referenced, 
			AbstractDocumentComponent parent) {
		super(referenced, Role.class, parent);
		// TODO Auto-generated constructor stub
	}

	public Role get() {
		// TODO Auto-generated method stub

		TTask task = TTask.class.cast(getParent());
		if (task.getPartnerLinkType() == null) {
			return getReferenced();
		}
		if (! task.getPartnerLinkType().isResolved()) 
			return null;
		PartnerLinkType partnerLT = task.getPartnerLinkType().get();
		Role role = partnerLT.getRole1();
		if (role != null && refString.equals(role.getName())) {
			setReferenced(Role.class.cast(role));
			return getReferenced();
		}
		role = partnerLT.getRole2();
		if (role != null && refString.equals(role.getName())) {
		  setReferenced(Role.class.cast(role));
		  return getReferenced();
		}

		return getReferenced();
	}


}
