/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 */

package org.foo.wavsupport;

import java.io.File;
import java.io.IOException;
import javax.sound.sampled.AudioFileFormat;
import org.foo.wavsupport.WavDataObject;
import org.foo.wavutils.Formats;
import org.foo.wavutils.WrappedAudioInputStream;
import org.openide.cookies.SaveCookie;
import org.openide.filesystems.FileUtil;

/**
 *
 * @author runger
 */
public class WavSaveCookie implements SaveCookie {

    private WavDataObject wav;

    public WavSaveCookie(WavDataObject wav)
    {
        this.wav = wav;
    }

    public void save() throws IOException {
        if (!wav.isModified())
            return;
        
        // get the linear PCM data
        WrappedAudioInputStream pcmStream = wav.getAudioInputStream();

        if (pcmStream != null)
        {
            File wavFile = FileUtil.toFile(wav.getPrimaryFile());

            // write out to mu-law format
            pcmStream.toFile(wavFile,
                             Formats.ULAW_FORMAT,
                             AudioFileFormat.Type.WAVE);
        }
        wav.setModified(false);
    }
}
