/*
 * CustomerEditorComponent.java
 *
 * Created on September 21, 2006, 2:17 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.examples.masterdetail.nodes;

import java.awt.BorderLayout;
import java.awt.KeyboardFocusManager;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.AbstractAction;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JSplitPane;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.ListView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;

/**
 *
 * @author Tim Boudreau
 */
final class CustomerEditorComponent extends TopComponent implements ExplorerManager.Provider, PropertyChangeListener {
    private final ExplorerManager mgr = new ExplorerManager();
    
    /** Creates a new instance of CustomerEditorComponent */
    public CustomerEditorComponent() {
        associateLookup (ExplorerUtils.createLookup (mgr, getActionMap()));
        Node root = new AbstractNode (new CustomerRootChildren());
        mgr.addPropertyChangeListener (this);
        mgr.setRootContext(root);
        
        setLayout (new BorderLayout());
        JSplitPane pane = new JSplitPane();
        pane.setDividerLocation(0.4D);
        pane.setResizeWeight(0.5D);
        add (pane, BorderLayout.CENTER);
        ListView lv = new ListView();
        lv.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        pane.setLeftComponent(lv);
        pane.setRightComponent(new CustomerPanel());
        setDisplayName (NbBundle.getMessage(CustomerEditorComponent.class,
                "LBL_MDVIEW"));
        
        getInputMap (WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(
                KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0, true),
                "up");
        getInputMap (WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(
                KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0, true),
                "down");
        getActionMap().put ("down", new UpDownAction(false));
        getActionMap().put ("up", new UpDownAction(true));
    }
    
    private final class UpDownAction extends AbstractAction {
        private final boolean up;
        private UpDownAction (boolean up) {
            this.up = up;
        }

        public void actionPerformed(ActionEvent e) {
            //XXX clean this up and use ExplorerManager...
            
            if (KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner()
                instanceof JComboBox) {
                return;
            }
            
            ListView lv = (ListView) ((JSplitPane) 
                CustomerEditorComponent.this.getComponents()[0]).getLeftComponent();
            
            JList l = (JList) lv.getViewport().getView();
            ListSelectionModel mdl = l.getSelectionModel();
            int ix = l.getSelectionModel().getLeadSelectionIndex() + 
                    (up ? -1 : 1);
            
            int max = l.getModel().getSize();
            if (ix == max) {
                ix = 0;
            } else if (ix < 0) {
                ix = max - 1;
            }
            if (ix >= 0) {
                mdl.setSelectionInterval(ix, ix);
            }
        }
    }

    public ExplorerManager getExplorerManager() {
        return mgr;
    }

    public void propertyChange(PropertyChangeEvent evt) {
        Node[] n = mgr.getSelectedNodes();
        setActivatedNodes(n);
        System.err.println(evt.getPropertyName());
//        if (n.length > 0) {
//            mgr.setExploredContext(n.length == 0 ? null : n[0]);
//        }
    }
}
