/*
 * CustomerNode.java
 *
 * Created on September 21, 2006, 3:49 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.examples.masterdetail.nodes;

import java.beans.IntrospectionException;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import org.netbeans.examples.masterdetail.api.Customer;
import org.openide.ErrorManager;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.PropertySupport;
import org.openide.nodes.Sheet;
import org.openide.util.WeakListeners;
import org.openide.util.lookup.Lookups;

/**
 *
 * @author Tim
 */
final class CustomerNode extends AbstractNode implements PropertyChangeListener {
    public CustomerNode(Customer c) throws IntrospectionException {
        super (Children.LEAF, Lookups.singleton(c));
        setDisplayName (c.toString());
        setName (c.getLastName() + c.getFirstName());
        setIconBaseWithExtension(
                "org/netbeans/examples/masterdetail/nodes/Customer.png");
        c.addPropertyChangeListener(WeakListeners.propertyChange(this,
                c));
    }

    public void propertyChange(PropertyChangeEvent evt) {
        final String nm = evt.getPropertyName();
        if (Customer.PROP_FIRST_NAME.equals(nm) || 
              Customer.PROP_LAST_NAME.equals(nm)) {
            Customer c = (Customer) evt.getSource();
            setDisplayName (c.toString());
        }
    }

    protected Sheet createSheet() {
        Sheet result = super.createSheet();
        Sheet.Set set = result.createPropertiesSet();
        Customer c = (Customer) getLookup().lookup (Customer.class);
        assert c != null;
        try {
            String[] s = Customer.PROPS;
            for (int i = 0; i < s.length; i++) {
                PropertySupport.Reflection prop = 
                        new PropertySupport.Reflection (c, String.class, s[i]);
                prop.setName(s[i]);
                prop.setDisplayName(Customer.getDisplayName(s[i]));
                set.put (prop);
            }
        } catch (NoSuchMethodException ex) {
            ErrorManager.getDefault().notify (ex);
        }
        result.put(set);
        return result;
    }
}
