package org.netbeans.examples.masterdetail.nodes;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.openide.windows.TopComponent;

final class OpenMasterDetailViewAction extends CallableSystemAction {
    
    public void performAction() {
        TopComponent tc = new CustomerEditorComponent();
        tc.open();
        tc.requestActive();
    }
    
    public String getName() {
        return NbBundle.getMessage(OpenMasterDetailViewAction.class, 
                "CTL_OpenMasterDetailViewAction");
    }
    
    protected void initialize() {
        super.initialize();
        // see org.openide.util.actions.SystemAction.iconResource() javadoc for more details
        putValue("noIconInMenu", Boolean.TRUE);
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    protected boolean asynchronous() {
        return false;
    }
}
