/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.ui;

import org.netbeans.pluginportal.system.*;

/**
 * A wrapper class to be used in a data provider for the my plugins table
 * @author David Botterill
 */
public class MyPlugin {
    
    /** Creates a new instance of MyPlugin */
    public MyPlugin() {
        setName("plugin name");
        setDownloads(100L);
        setQuality(QualityLevel.ALPHA.toString());
        setRating("0.0/5.0");
        setVersion("1.0");
    }

    /**
     * Holds value of property name.
     */
    private String name;

    /**
     * Getter for property name.
     * @return Value of property name.
     */
    public String getName() {
        return this.name;
    }

    /**
     * Setter for property name.
     * @param name New value of property name.
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Holds value of property version.
     */
    private String version;

    /**
     * Getter for property version.
     * @return Value of property version.
     */
    public String getVersion() {
        return this.version;
    }

    /**
     * Setter for property version.
     * @param version New value of property version.
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * Holds value of property quality.
     */
    private String quality;

    /**
     * Getter for property quality.
     * @return Value of property quality.
     */
    public String getQuality() {
        return this.quality;
    }

    /**
     * Setter for property quality.
     * @param quality New value of property quality.
     */
    public void setQuality(String quality) {
        this.quality = quality;
    }

    /**
     * Holds value of property rating.
     */
    private String rating;

    /**
     * Getter for property rating.
     * @return Value of property rating.
     */
    public String getRating() {
        return this.rating;
    }

    /**
     * Setter for property rating.
     * @param rating New value of property rating.
     */
    public void setRating(String rating) {
        this.rating = rating;
    }

    /**
     * Holds value of property downloads.
     */
    private Long downloads;

    /**
     * Getter for property downloads.
     * @return Value of property downloads.
     */
    public Long getDownloads() {
        return this.downloads;
    }

    /**
     * Setter for property downloads.
     * @param downloads New value of property downloads.
     */
    public void setDownloads(Long downloads) {
        this.downloads = downloads;
    }

    /**
     * Holds value of property pluginid.
     */
    private Long pluginid;

    /**
     * Getter for property pluginid.
     * @return Value of property pluginid.
     */
    public Long getPluginid() {
        return this.pluginid;
    }

    /**
     * Setter for property pluginid.
     * @param pluginid New value of property pluginid.
     */
    public void setPluginid(Long pluginid) {
        this.pluginid = pluginid;
    }

    /**
     * Holds value of property url.
     */
    private String url;

    /**
     * Getter for property url.
     * @return Value of property url.
     */
    public String getUrl() {
        return this.url;
    }

    /**
     * Setter for property url.
     * @param url New value of property url.
     */
    public void setUrl(String url) {
        this.url = url;
    }
    
    
    
}
