/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package pluginportal;

import com.sun.data.provider.RowKey;
import com.sun.j2ee.blueprints.ui.rating.RatingComponent;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Label;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.Table;
import com.sun.webui.jsf.component.TableColumn;
import com.sun.webui.jsf.component.TableRowGroup;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.convert.DateTimeConverter;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpServletRequest;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.SystemFileUtils;
import org.netbeans.pluginportal.ui.PluginDetail;
import org.netbeans.pluginportal.ui.PluginDetailComparator;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 * @author David Botterill
 */
public class CategoryPage extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
        dateTimeConverter1.setPattern("MMM dd, yyyy");
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private Link link2 = new Link();
    
    public Link getLink2() {
        return link2;
    }
    
    public void setLink2(Link l) {
        this.link2 = l;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink lnkHome = new Hyperlink();
    
    public Hyperlink getLnkHome() {
        return lnkHome;
    }
    
    public void setLnkHome(Hyperlink h) {
        this.lnkHome = h;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }
    
    private PanelGroup loginPanel = new PanelGroup();
    
    public PanelGroup getLoginPanel() {
        return loginPanel;
    }
    
    public void setLoginPanel(PanelGroup pg) {
        this.loginPanel = pg;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private Hyperlink currentUser = new Hyperlink();
    
    public Hyperlink getCurrentUser() {
        return currentUser;
    }
    
    public void setCurrentUser(Hyperlink h) {
        this.currentUser = h;
    }
    
    private Hyperlink txtLoginLogoff = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff() {
        return txtLoginLogoff;
    }
    
    public void setTxtLoginLogoff(Hyperlink h) {
        this.txtLoginLogoff = h;
    }
    
    private PanelLayout fixed_contextbox = new PanelLayout();
    
    public PanelLayout getFixed_contextbox() {
        return fixed_contextbox;
    }
    
    public void setFixed_contextbox(PanelLayout pl) {
        this.fixed_contextbox = pl;
    }
    
    private HtmlPanelGrid main_table = new HtmlPanelGrid();
    
    public HtmlPanelGrid getMain_table() {
        return main_table;
    }
    
    public void setMain_table(HtmlPanelGrid hpg) {
        this.main_table = hpg;
    }
    
    private PanelLayout left_col = new PanelLayout();
    
    public PanelLayout getLeft_col() {
        return left_col;
    }
    
    public void setLeft_col(PanelLayout pl) {
        this.left_col = pl;
    }
    
    private PanelLayout main_area1 = new PanelLayout();
    
    public PanelLayout getMain_area1() {
        return main_area1;
    }
    
    public void setMain_area1(PanelLayout pl) {
        this.main_area1 = pl;
    }
    
    private PanelLayout topPanel1 = new PanelLayout();
    
    public PanelLayout getTopPanel1() {
        return topPanel1;
    }
    
    public void setTopPanel1(PanelLayout pl) {
        this.topPanel1 = pl;
    }
    
    private PanelLayout bottomPanel = new PanelLayout();
    
    public PanelLayout getBottomPanel() {
        return bottomPanel;
    }
    
    public void setBottomPanel(PanelLayout pl) {
        this.bottomPanel = pl;
    }
    
    private PanelLayout right_col = new PanelLayout();
    
    public PanelLayout getRight_col() {
        return right_col;
    }
    
    public void setRight_col(PanelLayout pl) {
        this.right_col = pl;
    }
    
    private PanelLayout fixed_footer = new PanelLayout();
    
    public PanelLayout getFixed_footer() {
        return fixed_footer;
    }
    
    public void setFixed_footer(PanelLayout pl) {
        this.fixed_footer = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText9 = new StaticText();
    
    public StaticText getStaticText9() {
        return staticText9;
    }
    
    public void setStaticText9(StaticText st) {
        this.staticText9 = st;
    }
    
    private StaticText staticText10 = new StaticText();
    
    public StaticText getStaticText10() {
        return staticText10;
    }
    
    public void setStaticText10(StaticText st) {
        this.staticText10 = st;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText11 = new StaticText();
    
    public StaticText getStaticText11() {
        return staticText11;
    }
    
    public void setStaticText11(StaticText st) {
        this.staticText11 = st;
    }
    
    private Hyperlink hyperlink3 = new Hyperlink();
    
    public Hyperlink getHyperlink3() {
        return hyperlink3;
    }
    
    public void setHyperlink3(Hyperlink h) {
        this.hyperlink3 = h;
    }
    
    private StaticText staticText12 = new StaticText();
    
    public StaticText getStaticText12() {
        return staticText12;
    }
    
    public void setStaticText12(StaticText st) {
        this.staticText12 = st;
    }
    
    private StaticText staticText13 = new StaticText();
    
    public StaticText getStaticText13() {
        return staticText13;
    }
    
    public void setStaticText13(StaticText st) {
        this.staticText13 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText14 = new StaticText();
    
    public StaticText getStaticText14() {
        return staticText14;
    }
    
    public void setStaticText14(StaticText st) {
        this.staticText14 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText15 = new StaticText();
    
    public StaticText getStaticText15() {
        return staticText15;
    }
    
    public void setStaticText15(StaticText st) {
        this.staticText15 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText16 = new StaticText();
    
    public StaticText getStaticText16() {
        return staticText16;
    }
    
    public void setStaticText16(StaticText st) {
        this.staticText16 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private StaticText txtCategory = new StaticText();
    
    public StaticText getTxtCategory() {
        return txtCategory;
    }
    
    public void setTxtCategory(StaticText st) {
        this.txtCategory = st;
    }
    
    private PanelGroup linksByPanel = new PanelGroup();
    
    public PanelGroup getLinksByPanel() {
        return linksByPanel;
    }
    
    public void setLinksByPanel(PanelGroup pg) {
        this.linksByPanel = pg;
    }
    
    private StaticText staticText4 = new StaticText();
    
    public StaticText getStaticText4() {
        return staticText4;
    }
    
    public void setStaticText4(StaticText st) {
        this.staticText4 = st;
    }
    
    private Hyperlink lnkOrderByDate = new Hyperlink();
    
    public Hyperlink getLnkOrderByDate() {
        return lnkOrderByDate;
    }
    
    public void setLnkOrderByDate(Hyperlink h) {
        this.lnkOrderByDate = h;
    }
    
    private Hyperlink lnkOrderByRating = new Hyperlink();
    
    public Hyperlink getLnkOrderByRating() {
        return lnkOrderByRating;
    }
    
    public void setLnkOrderByRating(Hyperlink h) {
        this.lnkOrderByRating = h;
    }
    
    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }
    
    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private Markup markup3 = new Markup();
    
    public Markup getMarkup3() {
        return markup3;
    }
    
    public void setMarkup3(Markup m) {
        this.markup3 = m;
    }
    
    private Hyperlink pluginNameLink = new Hyperlink();
    
    public Hyperlink getPluginNameLink() {
        return pluginNameLink;
    }
    
    public void setPluginNameLink(Hyperlink h) {
        this.pluginNameLink = h;
    }
    
    private Markup markup4 = new Markup();
    
    public Markup getMarkup4() {
        return markup4;
    }
    
    public void setMarkup4(Markup m) {
        this.markup4 = m;
    }
    
    private PanelLayout categoryDetailPanel = new PanelLayout();
    
    public PanelLayout getCategoryDetailPanel() {
        return categoryDetailPanel;
    }
    
    public void setCategoryDetailPanel(PanelLayout pl) {
        this.categoryDetailPanel = pl;
    }
    
    private HtmlPanelGrid categoryDetailBottomGrid = new HtmlPanelGrid();
    
    public HtmlPanelGrid getCategoryDetailBottomGrid() {
        return categoryDetailBottomGrid;
    }
    
    public void setCategoryDetailBottomGrid(HtmlPanelGrid hpg) {
        this.categoryDetailBottomGrid = hpg;
    }
    
    private PanelLayout rightPanel = new PanelLayout();
    
    public PanelLayout getRightPanel() {
        return rightPanel;
    }
    
    public void setRightPanel(PanelLayout pl) {
        this.rightPanel = pl;
    }
    
    private RatingComponent rating1 = new RatingComponent();
    
    public RatingComponent getRating1() {
        return rating1;
    }
    
    public void setRating1(RatingComponent rc) {
        this.rating1 = rc;
    }
    
    private PanelLayout ratingPanel = new PanelLayout();
    
    public PanelLayout getRatingPanel() {
        return ratingPanel;
    }
    
    public void setRatingPanel(PanelLayout pl) {
        this.ratingPanel = pl;
    }
    
    private Markup markup5 = new Markup();
    
    public Markup getMarkup5() {
        return markup5;
    }
    
    public void setMarkup5(Markup m) {
        this.markup5 = m;
    }
    
    private Table table1 = new Table();
    
    public Table getTable1() {
        return table1;
    }
    
    public void setTable1(Table t) {
        this.table1 = t;
    }
    
    private TableRowGroup tableRowGroup1 = new TableRowGroup();
    
    public TableRowGroup getTableRowGroup1() {
        return tableRowGroup1;
    }
    
    public void setTableRowGroup1(TableRowGroup trg) {
        this.tableRowGroup1 = trg;
    }
    
    private Label label1 = new Label();
    
    public Label getLabel1() {
        return label1;
    }
    
    public void setLabel1(Label l) {
        this.label1 = l;
    }
    
    private Hyperlink lnkAuthor1 = new Hyperlink();
    
    public Hyperlink getLnkAuthor1() {
        return lnkAuthor1;
    }
    
    public void setLnkAuthor1(Hyperlink h) {
        this.lnkAuthor1 = h;
    }
    
    private Label label2 = new Label();
    
    public Label getLabel2() {
        return label2;
    }
    
    public void setLabel2(Label l) {
        this.label2 = l;
    }
    
    private StaticText txtDownloads = new StaticText();
    
    public StaticText getTxtDownloads() {
        return txtDownloads;
    }
    
    public void setTxtDownloads(StaticText st) {
        this.txtDownloads = st;
    }
    
    private StaticText txtSummary = new StaticText();
    
    public StaticText getTxtSummary() {
        return txtSummary;
    }
    
    public void setTxtSummary(StaticText st) {
        this.txtSummary = st;
    }
    
    private Markup markup11 = new Markup();
    
    public Markup getMarkup11() {
        return markup11;
    }
    
    public void setMarkup11(Markup m) {
        this.markup11 = m;
    }
    
    private Hyperlink lnkReadMore = new Hyperlink();
    
    public Hyperlink getLnkReadMore() {
        return lnkReadMore;
    }
    
    public void setLnkReadMore(Hyperlink h) {
        this.lnkReadMore = h;
    }
    
    private Markup markup12 = new Markup();
    
    public Markup getMarkup12() {
        return markup12;
    }
    
    public void setMarkup12(Markup m) {
        this.markup12 = m;
    }
    
    private Markup markup13 = new Markup();
    
    public Markup getMarkup13() {
        return markup13;
    }
    
    public void setMarkup13(Markup m) {
        this.markup13 = m;
    }
    
    private Markup markup14 = new Markup();
    
    public Markup getMarkup14() {
        return markup14;
    }
    
    public void setMarkup14(Markup m) {
        this.markup14 = m;
    }
    
    private PanelLayout leftPanel = new PanelLayout();
    
    public PanelLayout getLeftPanel() {
        return leftPanel;
    }
    
    public void setLeftPanel(PanelLayout pl) {
        this.leftPanel = pl;
    }
    
    private Markup markup15 = new Markup();
    
    public Markup getMarkup15() {
        return markup15;
    }
    
    public void setMarkup15(Markup m) {
        this.markup15 = m;
    }
    
    private TableColumn tableColumn1 = new TableColumn();
    
    public TableColumn getTableColumn1() {
        return tableColumn1;
    }
    
    public void setTableColumn1(TableColumn tc) {
        this.tableColumn1 = tc;
    }
    
    private PanelGroup groupPanel1 = new PanelGroup();
    
    public PanelGroup getGroupPanel1() {
        return groupPanel1;
    }
    
    public void setGroupPanel1(PanelGroup pg) {
        this.groupPanel1 = pg;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private StaticText staticText17 = new StaticText();
    
    public StaticText getStaticText17() {
        return staticText17;
    }
    
    public void setStaticText17(StaticText st) {
        this.staticText17 = st;
    }
    
    private PanelLayout right_col_area1 = new PanelLayout();
    
    public PanelLayout getRight_col_area1() {
        return right_col_area1;
    }
    
    public void setRight_col_area1(PanelLayout pl) {
        this.right_col_area1 = pl;
    }
    
    private StaticText staticText5 = new StaticText();
    
    public StaticText getStaticText5() {
        return staticText5;
    }
    
    public void setStaticText5(StaticText st) {
        this.staticText5 = st;
    }
    
    private Markup markup7 = new Markup();
    
    public Markup getMarkup7() {
        return markup7;
    }
    
    public void setMarkup7(Markup m) {
        this.markup7 = m;
    }
    
    private PanelLayout categoryLayout = new PanelLayout();
    
    public PanelLayout getCategoryLayout() {
        return categoryLayout;
    }
    
    public void setCategoryLayout(PanelLayout pl) {
        this.categoryLayout = pl;
    }
    
    private Markup markup8 = new Markup();
    
    public Markup getMarkup8() {
        return markup8;
    }
    
    public void setMarkup8(Markup m) {
        this.markup8 = m;
    }
    
    private ImageHyperlink lnkCloud = new ImageHyperlink();
    
    public ImageHyperlink getLnkCloud() {
        return lnkCloud;
    }
    
    public void setLnkCloud(ImageHyperlink ih) {
        this.lnkCloud = ih;
    }
    
    private Hyperlink lnkOrderByDownloads = new Hyperlink();
    
    public Hyperlink getLnkOrderByDownloads() {
        return lnkOrderByDownloads;
    }
    
    public void setLnkOrderByDownloads(Hyperlink h) {
        this.lnkOrderByDownloads = h;
    }
    
    private Hyperlink lnkOrderByName = new Hyperlink();
    
    public Hyperlink getLnkOrderByName() {
        return lnkOrderByName;
    }
    
    public void setLnkOrderByName(Hyperlink h) {
        this.lnkOrderByName = h;
    }
    
    private Label label3 = new Label();
    
    public Label getLabel3() {
        return label3;
    }
    
    public void setLabel3(Label l) {
        this.label3 = l;
    }
    
    private StaticText txtDateAdded = new StaticText();
    
    public StaticText getTxtDateAdded() {
        return txtDateAdded;
    }
    
    public void setTxtDateAdded(StaticText st) {
        this.txtDateAdded = st;
    }
    
    private DateTimeConverter dateTimeConverter1 = new DateTimeConverter();
    
    public DateTimeConverter getDateTimeConverter1() {
        return dateTimeConverter1;
    }
    
    public void setDateTimeConverter1(DateTimeConverter dtc) {
        this.dateTimeConverter1 = dtc;
    }
    
    private Markup markup16 = new Markup();
    
    public Markup getMarkup16() {
        return markup16;
    }
    
    public void setMarkup16(Markup m) {
        this.markup16 = m;
    }
    
    private HtmlPanelGrid gridPanel1 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel1() {
        return gridPanel1;
    }
    
    public void setGridPanel1(HtmlPanelGrid hpg) {
        this.gridPanel1 = hpg;
    }
    
    private PanelLayout orderByPanel = new PanelLayout();
    
    public PanelLayout getOrderByPanel() {
        return orderByPanel;
    }
    
    public void setOrderByPanel(PanelLayout pl) {
        this.orderByPanel = pl;
    }
    
    private ImageHyperlink imageHyperlink8 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink8() {
        return imageHyperlink8;
    }
    
    public void setImageHyperlink8(ImageHyperlink ih) {
        this.imageHyperlink8 = ih;
    }
    
    private Markup markup6 = new Markup();
    
    public Markup getMarkup6() {
        return markup6;
    }
    
    public void setMarkup6(Markup m) {
        this.markup6 = m;
    }
    
    private StaticText txtVersion = new StaticText();
    
    public StaticText getTxtVersion() {
        return txtVersion;
    }
    
    public void setTxtVersion(StaticText st) {
        this.txtVersion = st;
    }
    
    private Label label4 = new Label();
    
    public Label getLabel4() {
        return label4;
    }
    
    public void setLabel4(Label l) {
        this.label4 = l;
    }
    
    private HtmlPanelGrid gridPanel2 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel2() {
        return gridPanel2;
    }
    
    public void setGridPanel2(HtmlPanelGrid hpg) {
        this.gridPanel2 = hpg;
    }
    
    private PanelLayout namePanel = new PanelLayout();
    
    public PanelLayout getNamePanel() {
        return namePanel;
    }
    
    public void setNamePanel(PanelLayout pl) {
        this.namePanel = pl;
    }
    
    private Label label5 = new Label();
    
    public Label getLabel5() {
        return label5;
    }
    
    public void setLabel5(Label l) {
        this.label5 = l;
    }
    
    private StaticText txtDateUpdated = new StaticText();
    
    public StaticText getTxtDateUpdated() {
        return txtDateUpdated;
    }
    
    public void setTxtDateUpdated(StaticText st) {
        this.txtDateUpdated = st;
    }
    
    // </editor-fold>
    
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public CategoryPage() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("CategoryPage Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        if(null == getSessionBean1().getCurrentOrderBy()) {
            getSessionBean1().setCurrentOrderBy(OrderBy.NAME);
            lnkOrderByName.setDisabled(true);
        }
        
        getSessionBean1().setCurrentPageName("CategoryPage");
        
        
        /**
         * Process a GET type request.
         */
        HttpServletRequest request = (HttpServletRequest)FacesContext.getCurrentInstance().getExternalContext().getRequest();
        String [] categories = request.getParameterValues("categoryname");
        if(null != categories && categories.length == 1) {
            getSessionBean1().setCurrentCategoryName(categories[0]);
        }
        
    }
    
    
    private void loadPlugins() {
        if(null != this.getSessionBean1().getCurrentCategoryName()) {
            Plugin [] tempPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByCategory(this.getSessionBean1().getCurrentCategoryName(),getSessionBean1().isShowAllMode());
            if(null != tempPlugins) {
                ArrayList<PluginDetail> pluginList = new ArrayList();
                PluginDetail currentPlugin = null;
                for(int ii=0;ii < tempPlugins.length;ii++) {
                    currentPlugin = new PluginDetail();
                    currentPlugin.setAuthor(tempPlugins[ii].getAuthor_userid());
                    if(null == tempPlugins[ii].getImage_filename() ||
                            tempPlugins[ii].getImage_filename().equals("")) {
                        currentPlugin.setImage_url(FileUtils.defaultImage);
                    } else {
                        currentPlugin.setImage_url(SystemFileUtils.getImageURLString() + File.separator +  tempPlugins[ii].getImage_filename());
                    }
                    currentPlugin.setPluginid(tempPlugins[ii].getPluginid());
                    if(null == tempPlugins[ii].getNbm_filename() ||
                            tempPlugins[ii].getNbm_filename().equals("")) {
                        currentPlugin.setDownloads("not available");
                    } else {
                        if(null != tempPlugins[ii].getDownloads()) {
                            currentPlugin.setDownloads(Long.toString(tempPlugins[ii].getDownloads().longValue()));
                        } else {
                            currentPlugin.setDownloads("0");
                        }
                    }
                    currentPlugin.setName(tempPlugins[ii].getPlugin_name());
                    currentPlugin.setQuality_level(tempPlugins[ii].getQuality_level());
                    currentPlugin.setSummary(tempPlugins[ii].getSummary());
                    currentPlugin.setDate_added(tempPlugins[ii].getDate_added());
                    currentPlugin.setDate_updated(tempPlugins[ii].getDate_last_updated());
                    currentPlugin.setVersion(tempPlugins[ii].getVersion());
                    String dislplayCat = (String) this.getApplicationBean1().getDisplayCategoryMapById().get(tempPlugins[ii].getCategoryid());
                    currentPlugin.setDisplay_category(dislplayCat);
                    
                    /**
                     * Set the URL to a GET style
                     */
                    currentPlugin.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginDetailPage.jsp?pluginid=" + tempPlugins[ii].getPluginid());
                    currentPlugin.setOwnerUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginListPage.jsp?author=" + tempPlugins[ii].getAuthor_userid());
                    
                    if(null != tempPlugins[ii].getAverage_rating()) {
                        currentPlugin.setRating(tempPlugins[ii].getAverage_rating().doubleValue());
                    } else {
                        currentPlugin.setRating(0.0);
                    }
                    if(null!=tempPlugins[ii].getRatings()) {
                        currentPlugin.setTotal_raters(tempPlugins[ii].getRatings().size());
                    } else {
                        currentPlugin.setTotal_raters(0);
                    }
                    
                    currentPlugin.setAvgRatingText("Rated by " + currentPlugin.getTotal_raters() + " users.");
                    
                    pluginList.add(currentPlugin);
                }
                PluginDetail [] details = (PluginDetail [])pluginList.toArray(new PluginDetail[0]);
                
                /**
                 * Sort the details.
                 */
                Arrays.sort(details,new PluginDetailComparator(getSessionBean1().getCurrentOrderBy()));
                
                this.setCategoryPlugins(details);
                getSessionBean1().getCategoryPluginsDataProvider().setArray(this.getCategoryPlugins());
            }
        }
    }
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
        if(getSessionBean1().isCategoryInCloudView()) {
            lnkCloud.setImageURL("/resources/cloud_ctrl_display_as_cloud.png");
            lnkCloud.setToolTip("Click to show as List");
            if(null != this.getCategoryLayout().getChildren()) {
                this.getCategoryLayout().getChildren().clear();
            }
            
            ArrayList<Hyperlink> cloudLinks = this.getSessionBean1().getCategoryCloudLinks();
            /**
             * Now that we have the links, we need to add spaces between them
             * then add them to the panel.
             */
            ArrayList<UIComponent> categoryCloud = new ArrayList();
            Iterator<Hyperlink> cloudIterator = cloudLinks.iterator();
            StaticText spaceStaticText = null;
            while(cloudIterator.hasNext()) {
                Hyperlink currentLink = cloudIterator.next();
                categoryCloud.add(currentLink);
                spaceStaticText = new StaticText();
                spaceStaticText.setText("&nbsp;");
                spaceStaticText.setEscape(false);
                categoryCloud.add(spaceStaticText);
//            spaceStaticText = new StaticText();
//            spaceStaticText.setText("&nbsp;");
//            spaceStaticText.setEscape(false);
//            newList.add(spaceStaticText);
            }
            this.getCategoryLayout().getChildren().addAll(categoryCloud);
            
        } else {
            lnkCloud.setImageURL("/resources/cloud_ctrl_display_as_list.png");
            lnkCloud.setToolTip("Click to show as cloud");
            if(null != this.getCategoryLayout().getChildren()) {
                this.getCategoryLayout().getChildren().clear();
            }
            HtmlPanelGrid categoryPanel = new HtmlPanelGrid();
            /**
             * Populate the categoryPanel
             *
             */
            categoryPanel.getChildren().addAll(this.getSessionBean1().getCategoryList());
            this.getCategoryLayout().getChildren().add(categoryPanel);
        }
        
        /**
         * We need to load the array of MyPlugin for the data provider.
         * initially show ALL plugins.
         */
        loadPlugins();
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    
    public String currentUser_action() {
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().setCurrentUserId(null);
            return null;
        } else {
            this.getSessionBean1().setReturnFromLoginPage("category");
            return "login";
        }
        
    }
    
    
    /**
     * Holds value of property currentCategoryTitle.
     */
    private String currentCategoryTitle;
    
    /**
     * Getter for property currentCategoryTitle.
     * @return Value of property currentCategoryTitle.
     */
    public String getCurrentCategoryTitle() {
        return this.currentCategoryTitle;
    }
    
    /**
     * Setter for property currentCategoryTitle.
     * @param currentCategoryTitle New value of property currentCategoryTitle.
     */
    public void setCurrentCategoryTitle(String currentCategoryTitle) {
        this.currentCategoryTitle = currentCategoryTitle;
    }
    
    
    /**
     * Holds value of property orderByLinkText1.
     */
    private String orderByLinkText1;
    
    /**
     * Getter for property orderByLinkText1.
     * @return Value of property orderByLinkText1.
     */
    public String getOrderByLinkText1() {
        return this.orderByLinkText1;
    }
    
    /**
     * Setter for property orderByLinkText1.
     * @param orderByLinkText1 New value of property orderByLinkText1.
     */
    public void setOrderByLinkText1(String orderByLinkText1) {
        this.orderByLinkText1 = orderByLinkText1;
    }
    
    /**
     * Holds value of property orderByLinkText2.
     */
    private String orderByLinkText2;
    
    /**
     * Getter for property orderByLinkText2.
     * @return Value of property orderByLinkText2.
     */
    public String getOrderByLinkText2() {
        return this.orderByLinkText2;
    }
    
    /**
     * Setter for property orderByLinkText2.
     * @param orderByLinkText2 New value of property orderByLinkText2.
     */
    public void setOrderByLinkText2(String orderByLinkText2) {
        this.orderByLinkText2 = orderByLinkText2;
    }
    
    /**
     * Holds value of property categoryPlugins.
     */
    private PluginDetail [] categoryPlugins;
    
    /**
     * Getter for property categoryPlugins.
     * @return Value of property categoryPlugins.
     */
    public PluginDetail [] getCategoryPlugins() {
        return this.categoryPlugins;
    }
    
    /**
     * Setter for property categoryPlugins.
     * @param categoryPlugins New value of property categoryPlugins.
     */
    public void setCategoryPlugins(PluginDetail [] categoryPlugins) {
        this.categoryPlugins = categoryPlugins;
    }
    
    public String lnkShow_action() {
        if(getSessionBean1().isShowAllMode()) {
            getSessionBean1().setShowAllMode(false);
            getSessionBean1().setShowLinkText("All");
            getSessionBean1().setShowTitle("Show: Stable");
            loadPlugins();
        } else {
            getSessionBean1().setShowAllMode(true);
            getSessionBean1().setShowLinkText("Stable");
            getSessionBean1().setShowTitle("Show: All");
            loadPlugins();
        }
        
        return null;
    }
    
    public String category_action() {
        this.tableRowGroup1.setPage(1);
        return "category";
    }
    
    public void category_action(ActionEvent ae) {
        
        ActionEvent action = ae;
        String currentCategoryName = ((Hyperlink)ae.getComponent()).getType();
        getSessionBean1().setCurrentCategoryName(currentCategoryName);
        return;
    }
    
    
    public String orderByLink2_action() {
        if(getSessionBean1().getCurrentOrderBy().equals(OrderBy.NAME.toString())) {
            getSessionBean1().setOrderByTitle("Order by: Rating");
            getSessionBean1().setOrderByLinkText1("Name");
            getSessionBean1().setCurrentOrderBy(OrderBy.RATING);
        } else {
            getSessionBean1().setOrderByTitle("Order by: Name");
            getSessionBean1().setOrderByLinkText1("Rating");
            getSessionBean1().setCurrentOrderBy(OrderBy.NAME);
        }
        return null;
    }
    
    public String lnkHome_action() {
        
        return "home";
    }
    
    public String lnkAuthor1_action() {
        
        RowKey rowKey = tableRowGroup1.getRowKey();
        String searchString = (String) getSessionBean1().getCategoryPluginsDataProvider().getValue("author", rowKey);
        
        getSessionBean1().setCurrentSearchCriteria("Plugins for: " + searchString);
        
        Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor(searchString);
        getSessionBean1().setCurrentPlugins(foundPlugins);
        
        return "list";
    }
    
    public String pluginNameLink_action() {
        RowKey rowKey = tableRowGroup1.getRowKey();
        Long pluginid = (Long) getSessionBean1().getCategoryPluginsDataProvider().getValue("pluginid", rowKey);
        Plugin selectedPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(selectedPlugin);
        
        return "detail";
    }
    
    public String lnkCloud_action() {
        if(getSessionBean1().isCategoryInCloudView()) {
            getSessionBean1().setCategoryInCloudView(false);
        } else {
            getSessionBean1().setCategoryInCloudView(true);
        }
        return null;
    }
    
    
    public String lnkOrderByDate_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.DATE);
        lnkOrderByDate.setDisabled(true);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(false);
        return null;
    }
    public String lnkOrderByRating_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.RATING);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(true);
        
        return null;
    }
    
    public String lnkOrderByDownloads_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.DOWNLOADS);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(true);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(false);
        
        
        return null;
    }
    
    public String lnkOrderByName_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.NAME);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(true);
        lnkOrderByRating.setDisabled(false);
        
        return null;
    }
    
    public String lnkCategories_action() {
        RowKey rowKey = tableRowGroup1.getRowKey();
        String category = (String) this.getSessionBean1().getCategoryPluginsDataProvider().getValue("display_category", rowKey);
        
        getSessionBean1().setCurrentCategoryName(category);
        
        return "category";
    }
    
    
}

