/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.j2ee.blueprints.ui.autocomplete.AutoCompleteComponent;
import com.sun.j2ee.blueprints.ui.autocomplete.CompletionResult;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Button;
import com.sun.webui.jsf.component.Checkbox;
import com.sun.webui.jsf.component.DropDown;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Label;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.MessageGroup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.Property;
import com.sun.webui.jsf.component.PropertySheet;
import com.sun.webui.jsf.component.PropertySheetSection;
import com.sun.webui.jsf.component.Script;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.TextArea;
import com.sun.webui.jsf.component.TextField;
import com.sun.webui.jsf.component.Upload;
import com.sun.webui.jsf.model.Option;
import com.sun.webui.jsf.model.SingleSelectOptionsList;
import com.sun.webui.jsf.model.UploadedFile;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;
import java.util.Iterator;
import javax.faces.FacesException;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import org.netbeans.pluginportal.system.NBMDeploymentDescriptor;
import org.netbeans.pluginportal.system.OtherCategory;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.PluginException;
import org.netbeans.pluginportal.system.SystemFileUtils;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 *@author David Botterill
 */
public class ModifyPage extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Link link1 = new Link();
    
    public Link getLink1() {
        return link1;
    }
    
    public void setLink1(Link l) {
        this.link1 = l;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout fixed_footer = new PanelLayout();
    
    public PanelLayout getFixed_footer() {
        return fixed_footer;
    }
    
    public void setFixed_footer(PanelLayout pl) {
        this.fixed_footer = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText29 = new StaticText();
    
    public StaticText getStaticText29() {
        return staticText29;
    }
    
    public void setStaticText29(StaticText st) {
        this.staticText29 = st;
    }
    
    private StaticText staticText30 = new StaticText();
    
    public StaticText getStaticText30() {
        return staticText30;
    }
    
    public void setStaticText30(StaticText st) {
        this.staticText30 = st;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText31 = new StaticText();
    
    public StaticText getStaticText31() {
        return staticText31;
    }
    
    public void setStaticText31(StaticText st) {
        this.staticText31 = st;
    }
    
    private Hyperlink hyperlink3 = new Hyperlink();
    
    public Hyperlink getHyperlink3() {
        return hyperlink3;
    }
    
    public void setHyperlink3(Hyperlink h) {
        this.hyperlink3 = h;
    }
    
    private StaticText staticText32 = new StaticText();
    
    public StaticText getStaticText32() {
        return staticText32;
    }
    
    public void setStaticText32(StaticText st) {
        this.staticText32 = st;
    }
    
    private StaticText staticText33 = new StaticText();
    
    public StaticText getStaticText33() {
        return staticText33;
    }
    
    public void setStaticText33(StaticText st) {
        this.staticText33 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText34 = new StaticText();
    
    public StaticText getStaticText34() {
        return staticText34;
    }
    
    public void setStaticText34(StaticText st) {
        this.staticText34 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText35 = new StaticText();
    
    public StaticText getStaticText35() {
        return staticText35;
    }
    
    public void setStaticText35(StaticText st) {
        this.staticText35 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText36 = new StaticText();
    
    public StaticText getStaticText36() {
        return staticText36;
    }
    
    public void setStaticText36(StaticText st) {
        this.staticText36 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink hyperlink1 = new Hyperlink();
    
    public Hyperlink getHyperlink1() {
        return hyperlink1;
    }
    
    public void setHyperlink1(Hyperlink h) {
        this.hyperlink1 = h;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }
    
    private PanelGroup loginPanel1 = new PanelGroup();
    
    public PanelGroup getLoginPanel1() {
        return loginPanel1;
    }
    
    public void setLoginPanel1(PanelGroup pg) {
        this.loginPanel1 = pg;
    }
    
    private StaticText staticText37 = new StaticText();
    
    public StaticText getStaticText37() {
        return staticText37;
    }
    
    public void setStaticText37(StaticText st) {
        this.staticText37 = st;
    }
    
    private Hyperlink currentUser1 = new Hyperlink();
    
    public Hyperlink getCurrentUser1() {
        return currentUser1;
    }
    
    public void setCurrentUser1(Hyperlink h) {
        this.currentUser1 = h;
    }
    
    private Hyperlink txtLoginLogoff1 = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff1() {
        return txtLoginLogoff1;
    }
    
    public void setTxtLoginLogoff1(Hyperlink h) {
        this.txtLoginLogoff1 = h;
    }
    
    // </editor-fold>
    
    private Plugin plugin;
    
    private Script script1 = new Script();
    
    public Script getScript1() {
        return script1;
    }
    
    public void setScript1(Script s) {
        this.script1 = s;
    }
    
    private PanelLayout fixed_contextbox1 = new PanelLayout();
    
    public PanelLayout getFixed_contextbox1() {
        return fixed_contextbox1;
    }
    
    public void setFixed_contextbox1(PanelLayout pl) {
        this.fixed_contextbox1 = pl;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private PanelLayout generalPanel = new PanelLayout();
    
    public PanelLayout getGeneralPanel() {
        return generalPanel;
    }
    
    public void setGeneralPanel(PanelLayout pl) {
        this.generalPanel = pl;
    }
    
    private StaticText txtLogon1 = new StaticText();
    
    public StaticText getTxtLogon1() {
        return txtLogon1;
    }
    
    public void setTxtLogon1(StaticText st) {
        this.txtLogon1 = st;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private PanelLayout fieldPanel1 = new PanelLayout();
    
    public PanelLayout getFieldPanel1() {
        return fieldPanel1;
    }
    
    public void setFieldPanel1(PanelLayout pl) {
        this.fieldPanel1 = pl;
    }
    
    private TextField txtPluginName1 = new TextField();
    
    public TextField getTxtPluginName1() {
        return txtPluginName1;
    }
    
    public void setTxtPluginName1(TextField tf) {
        this.txtPluginName1 = tf;
    }
    
    private TextField txtLicenseType1 = new TextField();
    
    public TextField getTxtLicenseType1() {
        return txtLicenseType1;
    }
    
    public void setTxtLicenseType1(TextField tf) {
        this.txtLicenseType1 = tf;
    }
    
    private TextField txtHomePage1 = new TextField();
    
    public TextField getTxtHomePage1() {
        return txtHomePage1;
    }
    
    public void setTxtHomePage1(TextField tf) {
        this.txtHomePage1 = tf;
    }
    
    private TextField txtPrice1 = new TextField();
    
    public TextField getTxtPrice1() {
        return txtPrice1;
    }
    
    public void setTxtPrice1(TextField tf) {
        this.txtPrice1 = tf;
    }
    
    private TextField txtKeywords1 = new TextField();
    
    public TextField getTxtKeywords1() {
        return txtKeywords1;
    }
    
    public void setTxtKeywords1(TextField tf) {
        this.txtKeywords1 = tf;
    }
    
    private PanelLayout bottomPanel1 = new PanelLayout();
    
    public PanelLayout getBottomPanel1() {
        return bottomPanel1;
    }
    
    public void setBottomPanel1(PanelLayout pl) {
        this.bottomPanel1 = pl;
    }
    
    private AutoCompleteComponent txtOtherCategories = new AutoCompleteComponent();
    
    public AutoCompleteComponent getTxtOtherCategories() {
        return txtOtherCategories;
    }
    
    public void setTxtOtherCategories(AutoCompleteComponent acc) {
        this.txtOtherCategories = acc;
    }
    
    private Markup markup12 = new Markup();
    
    public Markup getMarkup12() {
        return markup12;
    }
    
    public void setMarkup12(Markup m) {
        this.markup12 = m;
    }
    
    private Label label2 = new Label();
    
    public Label getLabel2() {
        return label2;
    }
    
    public void setLabel2(Label l) {
        this.label2 = l;
    }
    
    private Markup markup13 = new Markup();
    
    public Markup getMarkup13() {
        return markup13;
    }
    
    public void setMarkup13(Markup m) {
        this.markup13 = m;
    }
    
    private TextArea txtSummary1 = new TextArea();
    
    public TextArea getTxtSummary1() {
        return txtSummary1;
    }
    
    public void setTxtSummary1(TextArea ta) {
        this.txtSummary1 = ta;
    }
    
    private Markup markup14 = new Markup();
    
    public Markup getMarkup14() {
        return markup14;
    }
    
    public void setMarkup14(Markup m) {
        this.markup14 = m;
    }
    
    private Label label3 = new Label();
    
    public Label getLabel3() {
        return label3;
    }
    
    public void setLabel3(Label l) {
        this.label3 = l;
    }
    
    private Markup markup15 = new Markup();
    
    public Markup getMarkup15() {
        return markup15;
    }
    
    public void setMarkup15(Markup m) {
        this.markup15 = m;
    }
    
    private TextArea txtDescription1 = new TextArea();
    
    public TextArea getTxtDescription1() {
        return txtDescription1;
    }
    
    public void setTxtDescription1(TextArea ta) {
        this.txtDescription1 = ta;
    }
    
    private Markup markup16 = new Markup();
    
    public Markup getMarkup16() {
        return markup16;
    }
    
    public void setMarkup16(Markup m) {
        this.markup16 = m;
    }
    
    private Upload txtImageFileUpload = new Upload();
    
    public Upload getTxtImageFileUpload() {
        return txtImageFileUpload;
    }
    
    public void setTxtImageFileUpload(Upload u) {
        this.txtImageFileUpload = u;
    }
    
    private Markup markup18 = new Markup();
    
    public Markup getMarkup18() {
        return markup18;
    }
    
    public void setMarkup18(Markup m) {
        this.markup18 = m;
    }
    
    private PanelGroup groupPanel1 = new PanelGroup();
    
    public PanelGroup getGroupPanel1() {
        return groupPanel1;
    }
    
    public void setGroupPanel1(PanelGroup pg) {
        this.groupPanel1 = pg;
    }
    
    private Button btnFinish1 = new Button();
    
    public Button getBtnFinish1() {
        return btnFinish1;
    }
    
    public void setBtnFinish1(Button b) {
        this.btnFinish1 = b;
    }
    
    private Button btnCancel1 = new Button();
    
    public Button getBtnCancel1() {
        return btnCancel1;
    }
    
    public void setBtnCancel1(Button b) {
        this.btnCancel1 = b;
    }
    
    private MessageGroup messageGroup1 = new MessageGroup();
    
    public MessageGroup getMessageGroup1() {
        return messageGroup1;
    }
    
    public void setMessageGroup1(MessageGroup mg) {
        this.messageGroup1 = mg;
    }
    
    private Markup markup19 = new Markup();
    
    public Markup getMarkup19() {
        return markup19;
    }
    
    public void setMarkup19(Markup m) {
        this.markup19 = m;
    }
    
    private Markup markup20 = new Markup();
    
    public Markup getMarkup20() {
        return markup20;
    }
    
    public void setMarkup20(Markup m) {
        this.markup20 = m;
    }
    
    private Upload txtNBMFileUpload = new Upload();
    
    public Upload getTxtNBMFileUpload() {
        return txtNBMFileUpload;
    }
    
    public void setTxtNBMFileUpload(Upload u) {
        this.txtNBMFileUpload = u;
    }
    
    private Markup markup21 = new Markup();
    
    public Markup getMarkup21() {
        return markup21;
    }
    
    public void setMarkup21(Markup m) {
        this.markup21 = m;
    }
    
    private TextArea txtNewForRevision = new TextArea();
    
    public TextArea getTxtNewForRevision() {
        return txtNewForRevision;
    }
    
    public void setTxtNewForRevision(TextArea ta) {
        this.txtNewForRevision = ta;
    }
    
    private Markup markup22 = new Markup();
    
    public Markup getMarkup22() {
        return markup22;
    }
    
    public void setMarkup22(Markup m) {
        this.markup22 = m;
    }
    
    private Label label4 = new Label();
    
    public Label getLabel4() {
        return label4;
    }
    
    public void setLabel4(Label l) {
        this.label4 = l;
    }
    
    private Markup markup23 = new Markup();
    
    public Markup getMarkup23() {
        return markup23;
    }
    
    public void setMarkup23(Markup m) {
        this.markup23 = m;
    }
    
    private Markup markup24 = new Markup();
    
    public Markup getMarkup24() {
        return markup24;
    }
    
    public void setMarkup24(Markup m) {
        this.markup24 = m;
    }
    
    private Markup markup25 = new Markup();
    
    public Markup getMarkup25() {
        return markup25;
    }
    
    public void setMarkup25(Markup m) {
        this.markup25 = m;
    }
    
    private Markup markup26 = new Markup();
    
    public Markup getMarkup26() {
        return markup26;
    }
    
    public void setMarkup26(Markup m) {
        this.markup26 = m;
    }
    
    private PanelLayout imagesPanel = new PanelLayout();
    
    public PanelLayout getImagesPanel() {
        return imagesPanel;
    }
    
    public void setImagesPanel(PanelLayout pl) {
        this.imagesPanel = pl;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private Markup markup11 = new Markup();
    
    public Markup getMarkup11() {
        return markup11;
    }
    
    public void setMarkup11(Markup m) {
        this.markup11 = m;
    }
    
    private Upload txtFullSizeImage = new Upload();
    
    public Upload getTxtFullSizeImage() {
        return txtFullSizeImage;
    }
    
    public void setTxtFullSizeImage(Upload u) {
        this.txtFullSizeImage = u;
    }
    
    private Markup markup27 = new Markup();
    
    public Markup getMarkup27() {
        return markup27;
    }
    
    public void setMarkup27(Markup m) {
        this.markup27 = m;
    }
    
    private Label label5 = new Label();
    
    public Label getLabel5() {
        return label5;
    }
    
    public void setLabel5(Label l) {
        this.label5 = l;
    }
    
    private HtmlPanelGrid gridPanel1 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel1() {
        return gridPanel1;
    }
    
    public void setGridPanel1(HtmlPanelGrid hpg) {
        this.gridPanel1 = hpg;
    }
    
    private Label label6 = new Label();
    
    public Label getLabel6() {
        return label6;
    }
    
    public void setLabel6(Label l) {
        this.label6 = l;
    }
    
    private PanelLayout nbmPanel = new PanelLayout();
    
    public PanelLayout getNbmPanel() {
        return nbmPanel;
    }
    
    public void setNbmPanel(PanelLayout pl) {
        this.nbmPanel = pl;
    }
    
    private StaticText staticText4 = new StaticText();
    
    public StaticText getStaticText4() {
        return staticText4;
    }
    
    public void setStaticText4(StaticText st) {
        this.staticText4 = st;
    }
    
    private StaticText staticText5 = new StaticText();
    
    public StaticText getStaticText5() {
        return staticText5;
    }
    
    public void setStaticText5(StaticText st) {
        this.staticText5 = st;
    }
    
    private PropertySheet propertySheet1 = new PropertySheet();
    
    public PropertySheet getPropertySheet1() {
        return propertySheet1;
    }
    
    public void setPropertySheet1(PropertySheet ps) {
        this.propertySheet1 = ps;
    }
    
    private PropertySheetSection section1 = new PropertySheetSection();
    
    public PropertySheetSection getSection1() {
        return section1;
    }
    
    public void setSection1(PropertySheetSection pss) {
        this.section1 = pss;
    }
    
    private Property name = new Property();
    
    public Property getName() {
        return name;
    }
    
    public void setName(Property p) {
        this.name = p;
    }
    
    private Property license = new Property();
    
    public Property getLicense() {
        return license;
    }
    
    public void setLicense(Property p) {
        this.license = p;
    }
    
    private Property homepage = new Property();
    
    public Property getHomepage() {
        return homepage;
    }
    
    public void setHomepage(Property p) {
        this.homepage = p;
    }
    
    private Property price = new Property();
    
    public Property getPrice() {
        return price;
    }
    
    public void setPrice(Property p) {
        this.price = p;
    }
    
    private Property keywords = new Property();
    
    public Property getKeywords() {
        return keywords;
    }
    
    public void setKeywords(Property p) {
        this.keywords = p;
    }
    
    private Property versionsSupported = new Property();
    
    public Property getVersionsSupported() {
        return versionsSupported;
    }
    
    public void setVersionsSupported(Property p) {
        this.versionsSupported = p;
    }
    
    private Property othercategories = new Property();
    
    public Property getOthercategories() {
        return othercategories;
    }
    
    public void setOthercategories(Property p) {
        this.othercategories = p;
    }
    
    private Property targetplatform = new Property();
    
    public Property getTargetplatform() {
        return targetplatform;
    }
    
    public void setTargetplatform(Property p) {
        this.targetplatform = p;
    }
    
    private Checkbox chkSolaris = new Checkbox();
    
    public Checkbox getChkSolaris() {
        return chkSolaris;
    }
    
    public void setChkSolaris(Checkbox c) {
        this.chkSolaris = c;
    }
    
    private Checkbox chkLinux = new Checkbox();
    
    public Checkbox getChkLinux() {
        return chkLinux;
    }
    
    public void setChkLinux(Checkbox c) {
        this.chkLinux = c;
    }
    
    private Checkbox chkMacOSX = new Checkbox();
    
    public Checkbox getChkMacOSX() {
        return chkMacOSX;
    }
    
    public void setChkMacOSX(Checkbox c) {
        this.chkMacOSX = c;
    }
    
    private Checkbox chkWindows = new Checkbox();
    
    public Checkbox getChkWindows() {
        return chkWindows;
    }
    
    public void setChkWindows(Checkbox c) {
        this.chkWindows = c;
    }
    
    private StaticText staticText6 = new StaticText();
    
    public StaticText getStaticText6() {
        return staticText6;
    }
    
    public void setStaticText6(StaticText st) {
        this.staticText6 = st;
    }
    
    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }
    
    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    private StaticText staticText7 = new StaticText();
    
    public StaticText getStaticText7() {
        return staticText7;
    }
    
    public void setStaticText7(StaticText st) {
        this.staticText7 = st;
    }
    
    private StaticText staticText8 = new StaticText();
    
    public StaticText getStaticText8() {
        return staticText8;
    }
    
    public void setStaticText8(StaticText st) {
        this.staticText8 = st;
    }
    
    private Property owner = new Property();
    
    public Property getOwner() {
        return owner;
    }
    
    public void setOwner(Property p) {
        this.owner = p;
    }
    
    private TextField txtOwner = new TextField();
    
    public TextField getTxtOwner() {
        return txtOwner;
    }
    
    public void setTxtOwner(TextField tf) {
        this.txtOwner = tf;
    }
    
    private TextField txtVersionsSupported = new TextField();
    
    public TextField getTxtVersionsSupported() {
        return txtVersionsSupported;
    }
    
    public void setTxtVersionsSupported(TextField tf) {
        this.txtVersionsSupported = tf;
    }
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public ModifyPage() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("ModifyPage Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        
    }
    
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
        /**
         * If the user is nbadmin, let them modify the owner.
         */
        if(getSessionBean1().getCurrentUserId().equals("nbadmin")) {
            owner.setVisible(true);
        } else {
            owner.setVisible(false);
        }
        
        /**
         * Fill the form with the current values.
         */
        plugin = this.getSessionBean1().getCurrentPlugin();
        if(null == plugin) {
            error("Error retrieving plugin!");
            return;
        }
        
        int categoryid = plugin.getCategoryid();
        Object objCat =this.getApplicationBean1().getDisplayCategoryMapById().get(categoryid);
        if(null != objCat) {
            String selectedCategory = (String)objCat;
            getSessionBean1().setSelectedDisplayCategory(selectedCategory);
        }
        
        setSelectedDevelopedWith(plugin.getVersions_supported());
        getSessionBean1().setSelectedDisplayCategory((String)getApplicationBean1().getDisplayCategoryMapById().get(plugin.getCategoryid()));
        
        if(null != getRequestBean1().getTargetPlatforms()) {
            String [] platforms=getRequestBean1().getTargetPlatforms().split(",");
            for(int ii=0; null != platforms && ii < platforms.length; ii++) {
                if(null != platforms[ii] && platforms[ii].equalsIgnoreCase("SOLARIS")) {
                    chkSolaris.setSelected("Solaris");
                } else if(null != platforms[ii] && platforms[ii].equalsIgnoreCase("LINUX")) {
                    chkLinux.setSelected("Linux");
                } else if(null != platforms[ii] && platforms[ii].equalsIgnoreCase("MAC OS X")) {
                    chkMacOSX.setSelected("Mac OS X");
                } else if(null != platforms[ii] && platforms[ii].equalsIgnoreCase("WINDOWS")) {
                    chkWindows.setSelected("Windows");
                }
                
            }
        }
        
        Iterator<OtherCategory> it = plugin.getOthercategories().iterator();
        String otherCategories="";
        while (it.hasNext()) {
            otherCategories += it.next().getCategoryname();
            if(it.hasNext()) {
                otherCategories += ",";
            }
        }
        txtOtherCategories.setText(otherCategories);
        
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    public String btnFinish_action() {
        
        Plugin plugin = getSessionBean1().getCurrentPlugin();
        
        if(null != this.txtImageFileUpload.getUploadedFile()) {
            long fileSize = this.txtImageFileUpload.getUploadedFile().getSize();
            if(fileSize > (1024L*1024L)) {
                error("Thumbnail image file size is too large:" + fileSize);
                return null;
            }
        }
        if(null != this.txtFullSizeImage.getUploadedFile()) {
            long fileSize = this.txtFullSizeImage.getUploadedFile().getSize();
            if(fileSize > (1024L*1024L)) {
                error("Full size image file size is too large:" + fileSize);
                return null;
            }
        }
        
        /**
         * Make sure the home page url is entered if required.
         */
        if((null == txtNBMFileUpload.getUploadedFile() || txtNBMFileUpload.getUploadedFile().getOriginalName().equals("")) &&
                (null == plugin.getNbm_filename() || plugin.getNbm_filename().equals("")) &&
                (null == txtHomePage1 || txtHomePage1.getText().equals(""))) {
            throw new ValidatorException(new FacesMessage("You must enter a home page URL for download purposes!"));
        }
        
        String selected = getSessionBean1().getSelectedDisplayCategory();
        plugin.setDate_last_updated(new Date());
        
        /**
         * Target Platforms.
         */
        
        String allSelected="";
        if(null != chkSolaris && chkSolaris.isChecked()) {
            allSelected += chkSolaris.getSelectedValue().toString() + ",";
        }
        if(null != chkLinux && chkLinux.isChecked()) {
            allSelected += chkLinux.getSelectedValue().toString() + ",";
        }
        if(null != chkMacOSX && chkMacOSX.isChecked()) {
            allSelected += chkMacOSX.getSelectedValue().toString() + ",";
        }
        if(null != chkWindows && chkWindows.isChecked()) {
            allSelected += chkWindows.getSelectedValue().toString() + ",";
        }
        plugin.setTarget_platforms(allSelected);
        /**
         * Process the thumbnail image file.
         */
        if(null != this.txtImageFileUpload.getUploadedFile() &&
                null != this.txtImageFileUpload.getUploadedFile().getOriginalName() &&
                !this.txtImageFileUpload.getUploadedFile().getOriginalName().equals("")) {
            String imageFilename = "";
            try {
                imageFilename = FileUtils.getImageFile(this.txtImageFileUpload.getUploadedFile());
            } catch (Exception ex) {
                log("Error Adding module",ex);
                error("Error adding Module!\n" + ex.getMessage());
                return null;
            }
            
            /**
             * Delete the old image file.
             */
            if(null != plugin.getImage_filename()) {
                String oldImageRealPath = SystemFileUtils.getImageLocation() + plugin.getImage_filename();
                File oldImageFile = new File(oldImageRealPath);
                oldImageFile.delete();
            }
            plugin.setImage_filename(imageFilename);
            
        }
        /**
         * Process the fullsize image file.
         */
        if(null != this.txtFullSizeImage.getUploadedFile() &&
                null != this.txtFullSizeImage.getUploadedFile().getOriginalName() &&
                !this.txtFullSizeImage.getUploadedFile().getOriginalName().equals("")) {
            String imageFilename = "";
            try {
                imageFilename = FileUtils.getImageFile(this.txtFullSizeImage.getUploadedFile());
            } catch (Exception ex) {
                log("Error Adding module",ex);
                error("Error adding Module!\n" + ex.getMessage());
                return null;
            }
            
            /**
             * Delete the old image file.
             */
            if(null != plugin.getFullsize_image_filename()) {
                String oldImageRealPath = SystemFileUtils.getImageLocation() + plugin.getImage_filename();
                File oldImageFile = new File(oldImageRealPath);
                oldImageFile.delete();
            }
            plugin.setFullsize_image_filename(imageFilename);
            
        }
        
        /**
         * Process the new NBM file.
         */
        if(null != txtNBMFileUpload.getUploadedFile() &&
                !txtNBMFileUpload.getUploadedFile().getOriginalName().equals("")) {
            
            String nbmFilename=null;
            try {
                nbmFilename = FileUtils.getNBMFile(txtNBMFileUpload.getUploadedFile());
            } catch (Exception ex) {
                log("Error Adding module",ex);
                error("Error adding Module!\n" + ex.getMessage());
                return null;
            }
            String fileName = txtNBMFileUpload.getUploadedFile().getOriginalName();
            String fileType = fileName.substring(fileName.lastIndexOf("."));
            
            
            
            
            /**
             * Delete the old NBM file.
             */
            if(null != plugin.getNbm_filename()) {
                String oldNBMRealPath = SystemFileUtils.getNbmLocation() + plugin.getNbm_filename();
                File oldNBMFile = new File(oldNBMRealPath);
                boolean deleted = oldNBMFile.delete();
            }
            
            plugin.setNbm_filename(nbmFilename);
            
            if(fileType.equalsIgnoreCase(".NBM")) {
                File infoFile=null;
                try {
                    String tmpFilename = SystemFileUtils.getNbmLocation() + File.separatorChar + nbmFilename;
                    infoFile = SystemFileUtils.extractInfoFile(tmpFilename);
                } catch (Exception ex) {
                    log("Error reading NBM file!",ex);
                    error("Error reading NBM file!  Make sure the file is a valid NBM file. \n" + ex.getMessage());
                    if(null != infoFile) {
                        infoFile.delete();
                    }
                    return null;
                }
                NBMDeploymentDescriptor nbmDD = new NBMDeploymentDescriptor(infoFile);
                plugin.setVersion(nbmDD.getOpenide_module_spec_version());
                plugin.setDisplaycategory(nbmDD.getOpenide_display_category());
                if(null != infoFile) {
                    infoFile.delete();
                }
            }
            
        }
        
        /**
         * Do the actual modify on the plugin system.
         */
        Plugin managedPlugin=null;
        try {
            managedPlugin = this.getApplicationBean1().getPluginSystem().modifyPlugin(plugin,this.getSessionBean1().getAuthToken(),this.getSessionBean1().getCurrentUserId());
        } catch (PluginException ex) {
            log("Error modifying Plugin=" + plugin.getPlugin_name());
            error("Error Modifying Plugin!\n" + ex.getMessage());
            return null;
        }
        
        /**
         * Now add the other categories
         */
        String allOtherCategories = (String)txtOtherCategories.getText();
        if(null != allOtherCategories && !allOtherCategories.equals("")) {
            String [] potentialCategories = allOtherCategories.split(",");
            if(null != potentialCategories) {
                OtherCategory newOtherCategory = null;
                /**
                 * Remove all the associated other categories first.
                 */
                try {
                    this.getApplicationBean1().getPluginSystem().removeOtherCategories(managedPlugin,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
                } catch (PluginException ex) {
                    log("Error Adding module",ex);
                    error("Error adding Module!\n" + ex.getMessage());
                    return null;
                }
                for(int ii=0; null != potentialCategories && ii < potentialCategories.length; ii++) {
                    newOtherCategory = this.getApplicationBean1().getPluginSystem().createOtherCategory();
                    newOtherCategory.setCategoryname(potentialCategories[ii].trim());
                    try {
                        this.getApplicationBean1().getPluginSystem().addOtherCategory(managedPlugin,newOtherCategory,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
                    } catch (PluginException ex) {
                        log("Error Adding module",ex);
                        error("Error adding Module!\n" + ex.getMessage());
                        return null;
                    }
                }
            }
        }
        
        /**
         * Now set the current plugin to the modified plugin on the session bean.
         */
        getSessionBean1().setCurrentPlugin(managedPlugin);
        
        return getSessionBean1().getReturnFromModifyPage();
    }
    
    public String hyperlink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String currentUser_action() {
        
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().logoff();
            return "home";
        } else {
            this.getSessionBean1().setReturnFromLoginPage("home");
            return "login";
        }
        
    }
    
    /**
     * Getter for property plugin.
     * @return Value of property plugin.
     */
    public Plugin getPlugin() {
        return this.plugin;
    }
    
    /**
     * Setter for property plugin.
     * @param plugin New value of property plugin.
     */
    public void setPlugin(Plugin plugin) {
        this.plugin = plugin;
    }
    
    
    public String btnCancel_action() {
        return getSessionBean1().getReturnFromModifyPage();
    }
    
    public void txtOtherCategories_complete(FacesContext context, String prefix, CompletionResult result) {
        String save_prefix = prefix;
        
        /**
         * break apart on "," (%2C = ,)
         */
        if(prefix.indexOf("%2C") != -1) {
            prefix = prefix.substring(prefix.lastIndexOf("%2C")+3);
        }
        String [] matchCategories = getApplicationBean1().getPluginSystem().matchOtherCategoryPrefix(prefix);
        
        result.addItems(matchCategories);
    }
    
    /**
     * Holds value of property selectedDevelopedWith.
     */
    private String selectedDevelopedWith;
    
    /**
     * Getter for property selectedDevelopedWith.
     * @return Value of property selectedDevelopedWith.
     */
    public String getSelectedDevelopedWith() {
        return this.selectedDevelopedWith;
    }
    
    /**
     * Setter for property selectedDevelopedWith.
     * @param selectedDevelopedWith New value of property selectedDevelopedWith.
     */
    public void setSelectedDevelopedWith(String selectedDevelopedWith) {
        this.selectedDevelopedWith = selectedDevelopedWith;
    }
    
    /**
     * Holds value of property selectedTargetPlatform.
     */
    private String[] selectedTargetPlatform;
    
    /**
     * Getter for property selectedTargetPlatform.
     * @return Value of property selectedTargetPlatform.
     */
    public String[] getSelectedTargetPlatform() {
        return this.selectedTargetPlatform;
    }
    
    /**
     * Setter for property selectedTargetPlatform.
     * @param selectedTargetPlatform New value of property selectedTargetPlatform.
     */
    public void setSelectedTargetPlatform(String[] selectedTargetPlatform) {
        this.selectedTargetPlatform = selectedTargetPlatform;
    }
    
    public void imageFile_validate(FacesContext context, UIComponent component, Object value) {
        
        UploadedFile upload = (UploadedFile)value;
        String fileName = upload.getOriginalName();
        if(null != fileName && !fileName.equals("")) {
            if(fileName.lastIndexOf(".") == -1) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .jpeg,.jpg,.png, or .gif file."));
            }
            String fileType = fileName.substring(fileName.lastIndexOf("."));
            if(!fileType.equalsIgnoreCase(".JPEG") &&
                    !fileType.equalsIgnoreCase(".JPG") &&
                    !fileType.equalsIgnoreCase(".PNG") &&
                    !fileType.equalsIgnoreCase(".GIF")) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .jpeg,.jpg,.png, or .gif file."));
            }
        }
    }
    
    public void nbmFile_validate(FacesContext context, UIComponent component, Object value) {
        UploadedFile upload = (UploadedFile)value;
        String fileName = upload.getOriginalName();
        if(null != fileName && !fileName.equals("")) {
            if(fileName.lastIndexOf(".") == -1) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .nbm or .zip file."));
            }
            String fileType = fileName.substring(fileName.lastIndexOf("."));
            if(!fileType.equalsIgnoreCase(".NBM") && !fileType.equalsIgnoreCase(".ZIP")) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .nbm or .zip file."));
            }
        }
    }
    
    public void txtHomePage1_validate(FacesContext context, UIComponent component, Object value) {
        
        
        /**
         * Make sure the string entered is a valid URL.
         */
        String homePage = null;
        
        if(null == value) {
            return;
        }
        
        homePage = (String)value;
        
        try {
            URL homePageURL = new URL(homePage);
        } catch(MalformedURLException mfue) {
            throw new ValidatorException(new FacesMessage("Invalid URL Specified!"));
        }
        
    }
    
}

