/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.data.provider.RowKey;
import com.sun.j2ee.blueprints.ui.rating.RatingComponent;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Button;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Label;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.MessageGroup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.Script;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.Table;
import com.sun.webui.jsf.component.TableColumn;
import com.sun.webui.jsf.component.TableRowGroup;
import com.sun.webui.jsf.component.TextArea;
import com.sun.webui.jsf.component.TextField;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.Date;
import java.util.TimeZone;
import javax.faces.FacesException;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.convert.DateTimeConverter;
import javax.faces.event.ActionEvent;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.netbeans.pluginportal.system.Comment;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.PluginException;
import org.netbeans.pluginportal.system.SystemFileUtils;
import org.netbeans.pluginportal.ui.SizeConverter;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 *@author David Botterill
 */
public class PluginDetailPage extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
        dateTimeConverter1.setPattern("MMM dd, yyyy - hh:mm:ss");
        dateTimeConverter1.setType("both");
        dateTimeConverter2.setPattern("MMM dd, yyyy");
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private Link link2 = new Link();
    
    public Link getLink2() {
        return link2;
    }
    
    public void setLink2(Link l) {
        this.link2 = l;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink hyperlink1 = new Hyperlink();
    
    public Hyperlink getHyperlink1() {
        return hyperlink1;
    }
    
    public void setHyperlink1(Hyperlink h) {
        this.hyperlink1 = h;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }
    
    private PanelGroup loginPanel1 = new PanelGroup();
    
    public PanelGroup getLoginPanel1() {
        return loginPanel1;
    }
    
    public void setLoginPanel1(PanelGroup pg) {
        this.loginPanel1 = pg;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private Hyperlink currentUser = new Hyperlink();
    
    public Hyperlink getCurrentUser() {
        return currentUser;
    }
    
    public void setCurrentUser(Hyperlink h) {
        this.currentUser = h;
    }
    
    private Hyperlink txtLoginLogoff = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff() {
        return txtLoginLogoff;
    }
    
    public void setTxtLoginLogoff(Hyperlink h) {
        this.txtLoginLogoff = h;
    }
    
    private PanelLayout fixed_footer1 = new PanelLayout();
    
    public PanelLayout getFixed_footer1() {
        return fixed_footer1;
    }
    
    public void setFixed_footer1(PanelLayout pl) {
        this.fixed_footer1 = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText9 = new StaticText();
    
    public StaticText getStaticText9() {
        return staticText9;
    }
    
    public void setStaticText9(StaticText st) {
        this.staticText9 = st;
    }
    
    private StaticText staticText10 = new StaticText();
    
    public StaticText getStaticText10() {
        return staticText10;
    }
    
    public void setStaticText10(StaticText st) {
        this.staticText10 = st;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText11 = new StaticText();
    
    public StaticText getStaticText11() {
        return staticText11;
    }
    
    public void setStaticText11(StaticText st) {
        this.staticText11 = st;
    }
    
    private Hyperlink hyperlink3 = new Hyperlink();
    
    public Hyperlink getHyperlink3() {
        return hyperlink3;
    }
    
    public void setHyperlink3(Hyperlink h) {
        this.hyperlink3 = h;
    }
    
    private StaticText staticText12 = new StaticText();
    
    public StaticText getStaticText12() {
        return staticText12;
    }
    
    public void setStaticText12(StaticText st) {
        this.staticText12 = st;
    }
    
    private StaticText staticText13 = new StaticText();
    
    public StaticText getStaticText13() {
        return staticText13;
    }
    
    public void setStaticText13(StaticText st) {
        this.staticText13 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText14 = new StaticText();
    
    public StaticText getStaticText14() {
        return staticText14;
    }
    
    public void setStaticText14(StaticText st) {
        this.staticText14 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText15 = new StaticText();
    
    public StaticText getStaticText15() {
        return staticText15;
    }
    
    public void setStaticText15(StaticText st) {
        this.staticText15 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText16 = new StaticText();
    
    public StaticText getStaticText16() {
        return staticText16;
    }
    
    public void setStaticText16(StaticText st) {
        this.staticText16 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private PanelLayout fixed_contextbox = new PanelLayout();
    
    public PanelLayout getFixed_contextbox() {
        return fixed_contextbox;
    }
    
    public void setFixed_contextbox(PanelLayout pl) {
        this.fixed_contextbox = pl;
    }
    
    private PanelLayout topPanel = new PanelLayout();
    
    public PanelLayout getTopPanel() {
        return topPanel;
    }
    
    public void setTopPanel(PanelLayout pl) {
        this.topPanel = pl;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private PanelLayout bottomPanel = new PanelLayout();
    
    public PanelLayout getBottomPanel() {
        return bottomPanel;
    }
    
    public void setBottomPanel(PanelLayout pl) {
        this.bottomPanel = pl;
    }
    
    private StaticText staticText5 = new StaticText();
    
    public StaticText getStaticText5() {
        return staticText5;
    }
    
    public void setStaticText5(StaticText st) {
        this.staticText5 = st;
    }
    
    private PanelLayout categoryDetailPanel = new PanelLayout();
    
    public PanelLayout getCategoryDetailPanel() {
        return categoryDetailPanel;
    }
    
    public void setCategoryDetailPanel(PanelLayout pl) {
        this.categoryDetailPanel = pl;
    }
    
    private Hyperlink pluginNameLink1 = new Hyperlink();
    
    public Hyperlink getPluginNameLink1() {
        return pluginNameLink1;
    }
    
    public void setPluginNameLink1(Hyperlink h) {
        this.pluginNameLink1 = h;
    }
    
    private Markup markup3 = new Markup();
    
    public Markup getMarkup3() {
        return markup3;
    }
    
    public void setMarkup3(Markup m) {
        this.markup3 = m;
    }
    
    private Markup markup5 = new Markup();
    
    public Markup getMarkup5() {
        return markup5;
    }
    
    public void setMarkup5(Markup m) {
        this.markup5 = m;
    }
    
    private Markup markup6 = new Markup();
    
    public Markup getMarkup6() {
        return markup6;
    }
    
    public void setMarkup6(Markup m) {
        this.markup6 = m;
    }
    
    private PanelLayout imagePanel = new PanelLayout();
    
    public PanelLayout getImagePanel() {
        return imagePanel;
    }
    
    public void setImagePanel(PanelLayout pl) {
        this.imagePanel = pl;
    }
    
    private ImageHyperlink lnkImage = new ImageHyperlink();
    
    public ImageHyperlink getLnkImage() {
        return lnkImage;
    }
    
    public void setLnkImage(ImageHyperlink ih) {
        this.lnkImage = ih;
    }
    
    private Markup markup7 = new Markup();
    
    public Markup getMarkup7() {
        return markup7;
    }
    
    public void setMarkup7(Markup m) {
        this.markup7 = m;
    }
    
    private Label label1 = new Label();
    
    public Label getLabel1() {
        return label1;
    }
    
    public void setLabel1(Label l) {
        this.label1 = l;
    }
    
    private Label label2 = new Label();
    
    public Label getLabel2() {
        return label2;
    }
    
    public void setLabel2(Label l) {
        this.label2 = l;
    }
    
    private Label label3 = new Label();
    
    public Label getLabel3() {
        return label3;
    }
    
    public void setLabel3(Label l) {
        this.label3 = l;
    }
    
    private Label label5 = new Label();
    
    public Label getLabel5() {
        return label5;
    }
    
    public void setLabel5(Label l) {
        this.label5 = l;
    }
    
    private StaticText txtWorksWith = new StaticText();
    
    public StaticText getTxtWorksWith() {
        return txtWorksWith;
    }
    
    public void setTxtWorksWith(StaticText st) {
        this.txtWorksWith = st;
    }
    
    private Markup markup15 = new Markup();
    
    public Markup getMarkup15() {
        return markup15;
    }
    
    public void setMarkup15(Markup m) {
        this.markup15 = m;
    }
    
    private StaticText staticText8 = new StaticText();
    
    public StaticText getStaticText8() {
        return staticText8;
    }
    
    public void setStaticText8(StaticText st) {
        this.staticText8 = st;
    }
    
    private StaticText txtSummary = new StaticText();
    
    public StaticText getTxtSummary() {
        return txtSummary;
    }
    
    public void setTxtSummary(StaticText st) {
        this.txtSummary = st;
    }
    
    private Markup markup17 = new Markup();
    
    public Markup getMarkup17() {
        return markup17;
    }
    
    public void setMarkup17(Markup m) {
        this.markup17 = m;
    }
    
    private StaticText staticText17 = new StaticText();
    
    public StaticText getStaticText17() {
        return staticText17;
    }
    
    public void setStaticText17(StaticText st) {
        this.staticText17 = st;
    }
    
    private StaticText txtRevisionNotes = new StaticText();
    
    public StaticText getTxtRevisionNotes() {
        return txtRevisionNotes;
    }
    
    public void setTxtRevisionNotes(StaticText st) {
        this.txtRevisionNotes = st;
    }
    
    private Markup markup19 = new Markup();
    
    public Markup getMarkup19() {
        return markup19;
    }
    
    public void setMarkup19(Markup m) {
        this.markup19 = m;
    }
    
    private StaticText staticText18 = new StaticText();
    
    public StaticText getStaticText18() {
        return staticText18;
    }
    
    public void setStaticText18(StaticText st) {
        this.staticText18 = st;
    }
    
    private Markup markup20 = new Markup();
    
    public Markup getMarkup20() {
        return markup20;
    }
    
    public void setMarkup20(Markup m) {
        this.markup20 = m;
    }
    
    private StaticText txtDescription = new StaticText();
    
    public StaticText getTxtDescription() {
        return txtDescription;
    }
    
    public void setTxtDescription(StaticText st) {
        this.txtDescription = st;
    }
    
    private PanelLayout commentPanel = new PanelLayout();
    
    public PanelLayout getCommentPanel() {
        return commentPanel;
    }
    
    public void setCommentPanel(PanelLayout pl) {
        this.commentPanel = pl;
    }
    
    private PanelLayout fieldPanel = new PanelLayout();
    
    public PanelLayout getFieldPanel() {
        return fieldPanel;
    }
    
    public void setFieldPanel(PanelLayout pl) {
        this.fieldPanel = pl;
    }
    
    private StaticText txtPrice = new StaticText();
    
    public StaticText getTxtPrice() {
        return txtPrice;
    }
    
    public void setTxtPrice(StaticText st) {
        this.txtPrice = st;
    }
    
    private StaticText txtDownloads = new StaticText();
    
    public StaticText getTxtDownloads() {
        return txtDownloads;
    }
    
    public void setTxtDownloads(StaticText st) {
        this.txtDownloads = st;
    }
    
    private Hyperlink lnkAuthor = new Hyperlink();
    
    public Hyperlink getLnkAuthor() {
        return lnkAuthor;
    }
    
    public void setLnkAuthor(Hyperlink h) {
        this.lnkAuthor = h;
    }
    
    private StaticText staticText19 = new StaticText();
    
    public StaticText getStaticText19() {
        return staticText19;
    }
    
    public void setStaticText19(StaticText st) {
        this.staticText19 = st;
    }
    
    private Markup markup25 = new Markup();
    
    public Markup getMarkup25() {
        return markup25;
    }
    
    public void setMarkup25(Markup m) {
        this.markup25 = m;
    }
    
    private PanelLayout summaryPanel = new PanelLayout();
    
    public PanelLayout getSummaryPanel() {
        return summaryPanel;
    }
    
    public void setSummaryPanel(PanelLayout pl) {
        this.summaryPanel = pl;
    }
    
    private Markup markup28 = new Markup();
    
    public Markup getMarkup28() {
        return markup28;
    }
    
    public void setMarkup28(Markup m) {
        this.markup28 = m;
    }
    
    private PanelLayout whatsnewPanel = new PanelLayout();
    
    public PanelLayout getWhatsnewPanel() {
        return whatsnewPanel;
    }
    
    public void setWhatsnewPanel(PanelLayout pl) {
        this.whatsnewPanel = pl;
    }
    
    private Markup markup29 = new Markup();
    
    public Markup getMarkup29() {
        return markup29;
    }
    
    public void setMarkup29(Markup m) {
        this.markup29 = m;
    }
    
    private PanelLayout descPanel = new PanelLayout();
    
    public PanelLayout getDescPanel() {
        return descPanel;
    }
    
    public void setDescPanel(PanelLayout pl) {
        this.descPanel = pl;
    }
    
    private Markup markup30 = new Markup();
    
    public Markup getMarkup30() {
        return markup30;
    }
    
    public void setMarkup30(Markup m) {
        this.markup30 = m;
    }
    
    private Markup markup31 = new Markup();
    
    public Markup getMarkup31() {
        return markup31;
    }
    
    public void setMarkup31(Markup m) {
        this.markup31 = m;
    }
    
    private PanelLayout commentInputPanel = new PanelLayout();
    
    public PanelLayout getCommentInputPanel() {
        return commentInputPanel;
    }
    
    public void setCommentInputPanel(PanelLayout pl) {
        this.commentInputPanel = pl;
    }
    
    private Label label7 = new Label();
    
    public Label getLabel7() {
        return label7;
    }
    
    public void setLabel7(Label l) {
        this.label7 = l;
    }
    
    private StaticText staticText7 = new StaticText();
    
    public StaticText getStaticText7() {
        return staticText7;
    }
    
    public void setStaticText7(StaticText st) {
        this.staticText7 = st;
    }
    
    private TextField txtNewCommentTitle = new TextField();
    
    public TextField getTxtNewCommentTitle() {
        return txtNewCommentTitle;
    }
    
    public void setTxtNewCommentTitle(TextField tf) {
        this.txtNewCommentTitle = tf;
    }
    
    private Markup markup32 = new Markup();
    
    public Markup getMarkup32() {
        return markup32;
    }
    
    public void setMarkup32(Markup m) {
        this.markup32 = m;
    }
    
    private Label label8 = new Label();
    
    public Label getLabel8() {
        return label8;
    }
    
    public void setLabel8(Label l) {
        this.label8 = l;
    }
    
    private Markup markup33 = new Markup();
    
    public Markup getMarkup33() {
        return markup33;
    }
    
    public void setMarkup33(Markup m) {
        this.markup33 = m;
    }
    
    private TextArea txtNewComment = new TextArea();
    
    public TextArea getTxtNewComment() {
        return txtNewComment;
    }
    
    public void setTxtNewComment(TextArea ta) {
        this.txtNewComment = ta;
    }
    
    private Button btnComment = new Button();
    
    public Button getBtnComment() {
        return btnComment;
    }
    
    public void setBtnComment(Button b) {
        this.btnComment = b;
    }
    
    private Markup markup34 = new Markup();
    
    public Markup getMarkup34() {
        return markup34;
    }
    
    public void setMarkup34(Markup m) {
        this.markup34 = m;
    }
    
    private Markup markup35 = new Markup();
    
    public Markup getMarkup35() {
        return markup35;
    }
    
    public void setMarkup35(Markup m) {
        this.markup35 = m;
    }
    
    private Button btnCommentSubmit = new Button();
    
    public Button getBtnCommentSubmit() {
        return btnCommentSubmit;
    }
    
    public void setBtnCommentSubmit(Button b) {
        this.btnCommentSubmit = b;
    }
    
    private Table commentTable = new Table();
    
    public Table getCommentTable() {
        return commentTable;
    }
    
    public void setCommentTable(Table t) {
        this.commentTable = t;
    }
    
    private TableRowGroup tableRowGroup = new TableRowGroup();
    
    public TableRowGroup getTableRowGroup() {
        return tableRowGroup;
    }
    
    public void setTableRowGroup(TableRowGroup trg) {
        this.tableRowGroup = trg;
    }
    
    private TableColumn tableColumn1 = new TableColumn();
    
    public TableColumn getTableColumn1() {
        return tableColumn1;
    }
    
    public void setTableColumn1(TableColumn tc) {
        this.tableColumn1 = tc;
    }
    
    private PanelGroup commentGroupPanel = new PanelGroup();
    
    public PanelGroup getCommentGroupPanel() {
        return commentGroupPanel;
    }
    
    public void setCommentGroupPanel(PanelGroup pg) {
        this.commentGroupPanel = pg;
    }
    
    private PanelLayout commentsPanel = new PanelLayout();
    
    public PanelLayout getCommentsPanel() {
        return commentsPanel;
    }
    
    public void setCommentsPanel(PanelLayout pl) {
        this.commentsPanel = pl;
    }
    
    private StaticText txtTitle1 = new StaticText();
    
    public StaticText getTxtTitle1() {
        return txtTitle1;
    }
    
    public void setTxtTitle1(StaticText st) {
        this.txtTitle1 = st;
    }
    
    private Markup markup27 = new Markup();
    
    public Markup getMarkup27() {
        return markup27;
    }
    
    public void setMarkup27(Markup m) {
        this.markup27 = m;
    }
    
    private Markup markup36 = new Markup();
    
    public Markup getMarkup36() {
        return markup36;
    }
    
    public void setMarkup36(Markup m) {
        this.markup36 = m;
    }
    
    private StaticText txtComment = new StaticText();
    
    public StaticText getTxtComment() {
        return txtComment;
    }
    
    public void setTxtComment(StaticText st) {
        this.txtComment = st;
    }
    
    private Markup markup37 = new Markup();
    
    public Markup getMarkup37() {
        return markup37;
    }
    
    public void setMarkup37(Markup m) {
        this.markup37 = m;
    }
    
    private StaticText staticText21 = new StaticText();
    
    public StaticText getStaticText21() {
        return staticText21;
    }
    
    public void setStaticText21(StaticText st) {
        this.staticText21 = st;
    }
    
    private StaticText staticText22 = new StaticText();
    
    public StaticText getStaticText22() {
        return staticText22;
    }
    
    public void setStaticText22(StaticText st) {
        this.staticText22 = st;
    }
    
    private Hyperlink lnkCommentUser = new Hyperlink();
    
    public Hyperlink getLnkCommentUser() {
        return lnkCommentUser;
    }
    
    public void setLnkCommentUser(Hyperlink h) {
        this.lnkCommentUser = h;
    }
    
    private StaticText staticText23 = new StaticText();
    
    public StaticText getStaticText23() {
        return staticText23;
    }
    
    public void setStaticText23(StaticText st) {
        this.staticText23 = st;
    }
    
    private StaticText staticText24 = new StaticText();
    
    public StaticText getStaticText24() {
        return staticText24;
    }
    
    public void setStaticText24(StaticText st) {
        this.staticText24 = st;
    }
    
    private StaticText txtCommentDate = new StaticText();
    
    public StaticText getTxtCommentDate() {
        return txtCommentDate;
    }
    
    public void setTxtCommentDate(StaticText st) {
        this.txtCommentDate = st;
    }
    
    private Markup markup38 = new Markup();
    
    public Markup getMarkup38() {
        return markup38;
    }
    
    public void setMarkup38(Markup m) {
        this.markup38 = m;
    }
    
    private StaticText staticText25 = new StaticText();
    
    public StaticText getStaticText25() {
        return staticText25;
    }
    
    public void setStaticText25(StaticText st) {
        this.staticText25 = st;
    }
    
    private Markup markup39 = new Markup();
    
    public Markup getMarkup39() {
        return markup39;
    }
    
    public void setMarkup39(Markup m) {
        this.markup39 = m;
    }
    
    private DateTimeConverter dateTimeConverter1 = new DateTimeConverter();
    
    public DateTimeConverter getDateTimeConverter1() {
        return dateTimeConverter1;
    }
    
    public void setDateTimeConverter1(DateTimeConverter dtc) {
        this.dateTimeConverter1 = dtc;
    }
    
    private MessageGroup messageGroup1 = new MessageGroup();
    
    public MessageGroup getMessageGroup1() {
        return messageGroup1;
    }
    
    public void setMessageGroup1(MessageGroup mg) {
        this.messageGroup1 = mg;
    }
    
    private Markup markup40 = new Markup();
    
    public Markup getMarkup40() {
        return markup40;
    }
    
    public void setMarkup40(Markup m) {
        this.markup40 = m;
    }
    
    private Markup markup41 = new Markup();
    
    public Markup getMarkup41() {
        return markup41;
    }
    
    public void setMarkup41(Markup m) {
        this.markup41 = m;
    }
    
    private Markup markup42 = new Markup();
    
    public Markup getMarkup42() {
        return markup42;
    }
    
    public void setMarkup42(Markup m) {
        this.markup42 = m;
    }
    
    private RatingComponent ratingIndividual = new RatingComponent();
    
    public RatingComponent getRatingIndividual() {
        return ratingIndividual;
    }
    
    public void setRatingIndividual(RatingComponent rc) {
        this.ratingIndividual = rc;
    }
    
    private Script script1 = new Script();
    
    public Script getScript1() {
        return script1;
    }
    
    public void setScript1(Script s) {
        this.script1 = s;
    }
    
    private Label label9 = new Label();
    
    public Label getLabel9() {
        return label9;
    }
    
    public void setLabel9(Label l) {
        this.label9 = l;
    }
    
    private Hyperlink lnkHomePage = new Hyperlink();
    
    public Hyperlink getLnkHomePage() {
        return lnkHomePage;
    }
    
    public void setLnkHomePage(Hyperlink h) {
        this.lnkHomePage = h;
    }
    
    private Label label10 = new Label();
    
    public Label getLabel10() {
        return label10;
    }
    
    public void setLabel10(Label l) {
        this.label10 = l;
    }
    
    private StaticText txtSize = new StaticText();
    
    public StaticText getTxtSize() {
        return txtSize;
    }
    
    public void setTxtSize(StaticText st) {
        this.txtSize = st;
    }
    
    private PanelLayout mustloginPanel = new PanelLayout();
    
    public PanelLayout getMustloginPanel() {
        return mustloginPanel;
    }
    
    public void setMustloginPanel(PanelLayout pl) {
        this.mustloginPanel = pl;
    }
    
    private Hyperlink lnkLogin = new Hyperlink();
    
    public Hyperlink getLnkLogin() {
        return lnkLogin;
    }
    
    public void setLnkLogin(Hyperlink h) {
        this.lnkLogin = h;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private StaticText staticText4 = new StaticText();
    
    public StaticText getStaticText4() {
        return staticText4;
    }
    
    public void setStaticText4(StaticText st) {
        this.staticText4 = st;
    }
    
    private StaticText staticText6 = new StaticText();
    
    public StaticText getStaticText6() {
        return staticText6;
    }
    
    public void setStaticText6(StaticText st) {
        this.staticText6 = st;
    }
    
    private Markup markup12 = new Markup();
    
    public Markup getMarkup12() {
        return markup12;
    }
    
    public void setMarkup12(Markup m) {
        this.markup12 = m;
    }
    
    private Label label4 = new Label();
    
    public Label getLabel4() {
        return label4;
    }
    
    public void setLabel4(Label l) {
        this.label4 = l;
    }
    
    private StaticText txtTargetPlatforms = new StaticText();
    
    public StaticText getTxtTargetPlatforms() {
        return txtTargetPlatforms;
    }
    
    public void setTxtTargetPlatforms(StaticText st) {
        this.txtTargetPlatforms = st;
    }
    
    private Label label12 = new Label();
    
    public Label getLabel12() {
        return label12;
    }
    
    public void setLabel12(Label l) {
        this.label12 = l;
    }
    
    private StaticText txtDateAdded = new StaticText();
    
    public StaticText getTxtDateAdded() {
        return txtDateAdded;
    }
    
    public void setTxtDateAdded(StaticText st) {
        this.txtDateAdded = st;
    }
    
    private Label label13 = new Label();
    
    public Label getLabel13() {
        return label13;
    }
    
    public void setLabel13(Label l) {
        this.label13 = l;
    }
    
    private StaticText txtDateLastUpdated = new StaticText();
    
    public StaticText getTxtDateLastUpdated() {
        return txtDateLastUpdated;
    }
    
    public void setTxtDateLastUpdated(StaticText st) {
        this.txtDateLastUpdated = st;
    }
    
    private DateTimeConverter dateTimeConverter2 = new DateTimeConverter();
    
    public DateTimeConverter getDateTimeConverter2() {
        return dateTimeConverter2;
    }
    
    public void setDateTimeConverter2(DateTimeConverter dtc) {
        this.dateTimeConverter2 = dtc;
    }
    
    private Button btnDownload = new Button();
    
    public Button getBtnDownload() {
        return btnDownload;
    }
    
    public void setBtnDownload(Button b) {
        this.btnDownload = b;
    }
    
    private HtmlPanelGrid gridPanel1 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel1() {
        return gridPanel1;
    }
    
    public void setGridPanel1(HtmlPanelGrid hpg) {
        this.gridPanel1 = hpg;
    }
    
    private Label label14 = new Label();
    
    public Label getLabel14() {
        return label14;
    }
    
    public void setLabel14(Label l) {
        this.label14 = l;
    }
    
    private ImageHyperlink lnkHideComment = new ImageHyperlink();
    
    public ImageHyperlink getLnkHideComment() {
        return lnkHideComment;
    }
    
    public void setLnkHideComment(ImageHyperlink ih) {
        this.lnkHideComment = ih;
    }
    
    private Markup markup4 = new Markup();
    
    public Markup getMarkup4() {
        return markup4;
    }
    
    public void setMarkup4(Markup m) {
        this.markup4 = m;
    }
    
    private HtmlPanelGrid topGrid = new HtmlPanelGrid();
    
    public HtmlPanelGrid getTopGrid() {
        return topGrid;
    }
    
    public void setTopGrid(HtmlPanelGrid hpg) {
        this.topGrid = hpg;
    }
    
    private Label label15 = new Label();
    
    public Label getLabel15() {
        return label15;
    }
    
    public void setLabel15(Label l) {
        this.label15 = l;
    }
    
    private StaticText txtKeywords = new StaticText();
    
    public StaticText getTxtKeywords() {
        return txtKeywords;
    }
    
    public void setTxtKeywords(StaticText st) {
        this.txtKeywords = st;
    }
    
    private Markup markup8 = new Markup();
    
    public Markup getMarkup8() {
        return markup8;
    }
    
    public void setMarkup8(Markup m) {
        this.markup8 = m;
    }
    
    private Markup markup9 = new Markup();
    
    public Markup getMarkup9() {
        return markup9;
    }
    
    public void setMarkup9(Markup m) {
        this.markup9 = m;
    }
    
    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }
    
    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    private PanelLayout layoutPanel1 = new PanelLayout();
    
    public PanelLayout getLayoutPanel1() {
        return layoutPanel1;
    }
    
    public void setLayoutPanel1(PanelLayout pl) {
        this.layoutPanel1 = pl;
    }
    
    private Label label16 = new Label();
    
    public Label getLabel16() {
        return label16;
    }
    
    public void setLabel16(Label l) {
        this.label16 = l;
    }
    
    private StaticText txtLicense = new StaticText();
    
    public StaticText getTxtLicense() {
        return txtLicense;
    }
    
    public void setTxtLicense(StaticText st) {
        this.txtLicense = st;
    }
    
    private Label label17 = new Label();
    
    public Label getLabel17() {
        return label17;
    }
    
    public void setLabel17(Label l) {
        this.label17 = l;
    }
    
    private PanelGroup categoryPanel = new PanelGroup();
    
    public PanelGroup getCategoryPanel() {
        return categoryPanel;
    }
    
    public void setCategoryPanel(PanelGroup pg) {
        this.categoryPanel = pg;
    }
    
    private Markup markup10 = new Markup();
    
    public Markup getMarkup10() {
        return markup10;
    }
    
    public void setMarkup10(Markup m) {
        this.markup10 = m;
    }
    
    private HtmlPanelGrid manifestgrid = new HtmlPanelGrid();
    
    public HtmlPanelGrid getManifestgrid() {
        return manifestgrid;
    }
    
    public void setManifestgrid(HtmlPanelGrid hpg) {
        this.manifestgrid = hpg;
    }
    
    private Label label11 = new Label();
    
    public Label getLabel11() {
        return label11;
    }
    
    public void setLabel11(Label l) {
        this.label11 = l;
    }
    
    private PanelLayout manifestPanel = new PanelLayout();
    
    public PanelLayout getManifestPanel() {
        return manifestPanel;
    }
    
    public void setManifestPanel(PanelLayout pl) {
        this.manifestPanel = pl;
    }
    
    private Markup markup11 = new Markup();
    
    public Markup getMarkup11() {
        return markup11;
    }
    
    public void setMarkup11(Markup m) {
        this.markup11 = m;
    }
    
    private Label label18 = new Label();
    
    public Label getLabel18() {
        return label18;
    }
    
    public void setLabel18(Label l) {
        this.label18 = l;
    }
    
    private StaticText txtSpecVersion = new StaticText();
    
    public StaticText getTxtSpecVersion() {
        return txtSpecVersion;
    }
    
    public void setTxtSpecVersion(StaticText st) {
        this.txtSpecVersion = st;
    }
    
    private Label label6 = new Label();
    
    public Label getLabel6() {
        return label6;
    }
    
    public void setLabel6(Label l) {
        this.label6 = l;
    }
    
    private StaticText txtDisplayCategory = new StaticText();
    
    public StaticText getTxtDisplayCategory() {
        return txtDisplayCategory;
    }
    
    public void setTxtDisplayCategory(StaticText st) {
        this.txtDisplayCategory = st;
    }
    
    private Button btnUpdate = new Button();
    
    public Button getBtnUpdate() {
        return btnUpdate;
    }
    
    public void setBtnUpdate(Button b) {
        this.btnUpdate = b;
    }
    
    // </editor-fold>
    
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public PluginDetailPage() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("PluginDetailPage Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        
        getSessionBean1().setCommentBoxVisible(false);
        getSessionBean1().setCommentButtonVisible(true);
        
        if(getSessionBean1().isLoggedIn()) {
            ratingIndividual.setInAverageMode(true);
        } else {
            ratingIndividual.setInAverageMode(false);
        }
        
        if(getSessionBean1().isAttemptedComment()) {
            getSessionBean1().setCommentBoxVisible(true);
            getSessionBean1().setCommentButtonVisible(false);
            getSessionBean1().setHideCommentLinkVisible(true);
            getSessionBean1().setAttemptedComment(false);
        }
        
        dateTimeConverter1.setTimeZone(TimeZone.getDefault());
        
        /**
         * Process a GET type request.
         */
        HttpServletRequest request = (HttpServletRequest)FacesContext.getCurrentInstance().getExternalContext().getRequest();
        String [] pluginids = request.getParameterValues("pluginid");
        if(null != pluginids && pluginids.length == 1) {
            try {
                Long pluginid = new Long(Long.parseLong(pluginids[0]));
                Plugin currentPlugin = getApplicationBean1().getPluginSystem().getPlugin(pluginid);
                if(null != currentPlugin) {
                    getSessionBean1().setCurrentPlugin(currentPlugin);
                }
            } catch(NumberFormatException nfe) {
                
            }
        }
        initializeInformation();
    }
    private void loadComments() {
        if(null != this.getSessionBean1() &&
                null != this.getSessionBean1().getCurrentPlugin() &&
                null != this.getSessionBean1().getCurrentPlugin().getPluginid()) {
            Comment [] tempComments = this.getApplicationBean1().getPluginSystem().getComments(getSessionBean1().getCurrentPlugin().getPluginid().intValue());
            if(null != tempComments) {
                ArrayList<CommentDetail> commentList = new ArrayList();
                CommentDetail currentComment = null;
                for(int ii=0;ii < tempComments.length;ii++) {
                    currentComment = new CommentDetail();
                    currentComment.setComment_summary(tempComments[ii].getComment_summary());
                    currentComment.setDate_entered(tempComments[ii].getDate_entered());
                    currentComment.setId(tempComments[ii].getId());
                    currentComment.setTitle(tempComments[ii].getTitle());
                    currentComment.setUserid(tempComments[ii].getUserid());
                    
                    commentList.add(currentComment);
                }
                CommentDetail [] details = (CommentDetail [])commentList.toArray(new CommentDetail[0]);
                
                this.setPluginComments(details);
                getSessionBean1().getCommentDataProvider().setArray(this.getPluginComments());
                
            }
        }
    }
    
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
        
        /**
         * we need to load the comments in the dataprovider.
         */
        loadComments();
        
    }
    
    public void initializeInformation() {
        if(!getSessionBean1().isLoggedIn()) {
            mustloginPanel.setVisible(true);
        } else {
            mustloginPanel.setVisible(false);
        }
        
        Plugin currentPlugin = this.getSessionBean1().getCurrentPlugin();
        
        if(null == currentPlugin) {
            return;
        }
        
        if(null != currentPlugin && null != currentPlugin.getVersions_supported()) {
            txtWorksWith.setText(currentPlugin.getVersions_supported());
        }
        
        /**
         * If someone is logged in and that user is the same as the plugin owner or nbadmin, show the
         * Update button.
         */
        if(getSessionBean1().isLoggedIn() &&
                (getSessionBean1().getCurrentUserId().equals(currentPlugin.getAuthor_userid()) ||
                getSessionBean1().getCurrentUserId().equals("nbadmin"))) {
            btnUpdate.setVisible(true);
        } else {
            btnUpdate.setVisible(false);
        }
        
        if(null == currentPlugin.getImage_filename() ||
                currentPlugin.getImage_filename().equals("")) {
            lnkImage.setImageURL(FileUtils.defaultImage);
        } else {
            lnkImage.setImageURL(SystemFileUtils.getImageURLString() + File.separator +  currentPlugin.getImage_filename());
        }
        if(null != currentPlugin.getFullsize_image_filename() &&
                !currentPlugin.getFullsize_image_filename().equals("")) {
            lnkImage.setUrl(SystemFileUtils.getImageURLString() + File.separator +  currentPlugin.getFullsize_image_filename());
        }
        
        /**
         * Hide the download button if there is not a NBM file.
         */
//        if(null == currentPlugin.getNbm_filename() || currentPlugin.getNbm_filename().equals("")) {
//            btnDownload.setVisible(false);
//        } else {
//            btnDownload.setVisible(true);
//        }
        
        /**
         * we need to load the comments in the dataprovider.
         */
        loadComments();
        
        /**
         * Load all the categories.
         */
        if(null != this.getCategoryPanel().getChildren()) {
            this.getCategoryPanel().getChildren().clear();
        }
        
        this.getCategoryPanel().getChildren().addAll(this.getSessionBean1().getCategoryHyperlinkList(getSessionBean1().getCurrentPlugin()));
        
        /**
         * Set the manifest panel invisible if there is NOT an NBM file.
         */
        if(null == getSessionBean1().getCurrentPlugin().getNbm_filename() ||
                getSessionBean1().getCurrentPlugin().getNbm_filename().equals("")) {
            manifestPanel.setVisible(false);
            txtDownloads.setText("not available");
        } else {
            if(null != getSessionBean1().getCurrentPlugin().getDownloads()) {
                txtDownloads.setText(Long.toString( getSessionBean1().getCurrentPlugin().getDownloads().longValue()));
            } else {
                txtDownloads.setText("0");
            }
            manifestPanel.setVisible(true);
        }
        
        
        lnkAuthor.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginListPage.jsp?author=" + getSessionBean1().getCurrentPlugin().getAuthor_userid());
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    public String imageHyperlink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String imageHyperlink2_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String imageHyperlink3_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String imageHyperlink4_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String imageHyperlink5_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String imageHyperlink6_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String currentUser_action() {
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().setCurrentUserId(null);
            return null;
        } else {
            this.getSessionBean1().setReturnFromLoginPage("detail");
            return "login";
        }
    }
    
    public String lnkShow_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String orderByLink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink2_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink3_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink4_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink8_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink7_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink5_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String btnNext_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String btnCancel_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String lnkAuthor_action() {
        getSessionBean1().setCurrentSearchCriteria("Plugins for: " + (String)lnkAuthor.getText());
        
        Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor((String)lnkAuthor.getText());
        getSessionBean1().setCurrentPlugins(foundPlugins);
        
        return "list";
    }
    
    public String btnRate_action() {
        if(!this.getSessionBean1().isLoggedIn()) {
            /**
             * Set the page to return to after login.
             */
            this.getSessionBean1().setReturnFromLoginPage("detail");
            
            
            try {
                FacesContext.getCurrentInstance().getExternalContext().redirect("faces/LoginPage.jsp");
            } catch (IOException ex) {
                log("Error redirecting to login page! IOException=" + ex.getMessage());
            }
            
        }
        return null;
    }
    
    public String btnComment_action() {
        if(!getSessionBean1().isLoggedIn()) {
            getSessionBean1().setReturnFromLoginPage("detail");
            getSessionBean1().setAttemptedComment(true);
            
            try {
                FacesContext.getCurrentInstance().getExternalContext().redirect("faces/LoginPage.jsp");
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        } else {
            getSessionBean1().setCommentBoxVisible(true);
            getSessionBean1().setCommentButtonVisible(false);
            getSessionBean1().setHideCommentLinkVisible(true);
        }
        
        
        return null;
    }
    
    public String lnkHideCommentInput_action() {
        getSessionBean1().setCommentBoxVisible(false);
        getSessionBean1().setCommentButtonVisible(true);
        getSessionBean1().setHideCommentLinkVisible(false);
        
        return null;
    }
    
    /**
     * Holds value of property pluginComments.
     */
    private CommentDetail[] pluginComments;
    
    /**
     * Getter for property pluginComments.
     * @return Value of property pluginComments.
     */
    public CommentDetail[] getPluginComments() {
        return this.pluginComments;
    }
    
    /**
     * Setter for property pluginComments.
     * @param pluginComments New value of property pluginComments.
     */
    public void setPluginComments(CommentDetail[] pluginComments) {
        this.pluginComments = pluginComments;
    }
    
    public String btnCommentSubmit_action() {
        if(null == txtNewCommentTitle.getText() ||
                txtNewCommentTitle.getText().equals("")) {
            error("You must enter a title for the comment!");
            return null;
        }
        
        if(null == txtNewComment.getText() ||
                txtNewComment.getText().equals("")) {
            error("You must enter a comment!");
            return null;
        }
        
        Comment newComment = getApplicationBean1().getPluginSystem().createComment();
        newComment.setComment_summary((String)txtNewComment.getText());
        newComment.setDate_entered(new Date());
        newComment.setTitle((String)txtNewCommentTitle.getText());
        newComment.setUserid(getSessionBean1().getCurrentUserId());
        
        try {
            Plugin modifiedPlugin = getApplicationBean1().getPluginSystem().addComment(
                    getSessionBean1().getCurrentPlugin(),
                    newComment,
                    getSessionBean1().getAuthToken(),
                    getSessionBean1().getCurrentUserId()
                    );
            getSessionBean1().setCurrentPlugin(modifiedPlugin);
        } catch (PluginException ex) {
            error("Error adding Comment: Exception=\n" + ex.getMessage());
            return null;
        }
        
        lnkHideCommentInput_action();
        
        return "detail";
    }
    
    public String lnkRate_action() {
        
        if(!this.getSessionBean1().isLoggedIn()) {
            /**
             * Set the page to return to after login.
             */
            this.getSessionBean1().setReturnFromLoginPage("detail");
            
            
            try {
                FacesContext.getCurrentInstance().getExternalContext().redirect("faces/LoginPage.jsp");
            } catch (IOException ex) {
                log("Error redirecting to login page! IOException=" + ex.getMessage());
            }
            
        } else {
            getSessionBean1().setMyRatingPanelVisible(true);
        }
        
        return null;
    }
    
    
    public void downloadselect_action(ActionEvent ae) {
        try {
            FacesContext.getCurrentInstance().getExternalContext().redirect("faces/" + SystemFileUtils.nbmFileLocation + File.separator + getSessionBean1().getCurrentPlugin().getNbm_filename());
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        Plugin currentPlugin = getSessionBean1().getCurrentPlugin();
        currentPlugin.setDownloads(currentPlugin.getDownloads()+1);
        try {
            Plugin modifiedPlugin = getApplicationBean1().getPluginSystem().modifyPlugin(currentPlugin,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
            getSessionBean1().setCurrentPlugin(modifiedPlugin);
        } catch (PluginException ex) {
            log("Error counting download=" + ex.getMessage());
            error("Error counting download=" + ex.getMessage());
        }
        
        return;
    }
    
    public String lnkDownload_action() {
        
        
        Plugin currentPlugin = getSessionBean1().getCurrentPlugin();
        currentPlugin.setDownloads(currentPlugin.getDownloads()+1);
        try {
            getApplicationBean1().getPluginSystem().modifyPlugin(currentPlugin,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
        } catch (PluginException ex) {
            log("Error counting download=" + ex.getMessage());
            error("Error counting download=" + ex.getMessage());
        }
        
        return "detail";
    }
    
    public String lnkCommentUser_action() {
        RowKey rowKey = tableRowGroup.getRowKey();
        String searchString = (String) this.getSessionBean1().getCommentDataProvider().getValue("userid", rowKey);
        
        getSessionBean1().setCurrentSearchCriteria("Plugins for: " + searchString);
        
        Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor(searchString);
        getSessionBean1().setCurrentPlugins(foundPlugins);
        
        return "list";
    }
    
    public String btnDownload_action() {
        if(null == getSessionBean1().getCurrentPlugin()) {
            return null;
        }
        
        String filename = getSessionBean1().getCurrentPlugin().getNbm_filename();
        
        
        /**
         * If the file isn't in the plugin portal, we will redirect to the homepage if it exists.
         */
        if(null == filename || filename.equals("")) {
            String homePage = getSessionBean1().getCurrentPlugin().getHome_page_url();
            if(null != homePage && !homePage.equals("")) {
                try {
                    FacesContext.getCurrentInstance().getExternalContext().redirect(homePage);
                } catch (IOException ex) {
                    error("Exception trying to forward to plugin homepage!\n Exception=" + ex.getMessage());
                }
                FacesContext.getCurrentInstance().responseComplete();
            } else {
                error("Home page URL is invalid!  Plugin Portal can not forward to Plugin home page.");
            }
            
        } else {
            /**
             * Push the file out.
             *
             * We have to push the file file to the response output stream with the correct content type
             * or the file will be corrupted.  Also, we can't just use a hyperlink since we need to record
             * the download for the plugin.
             *
             * Also, this code can NOT be done for a hyperlink action because the way JSF deals with hyperlinks.
             */
            
            String contentType = "application/x-download"; // For dialog, try application/x-download
            String realPath = SystemFileUtils.getNbmLocation() + File.separator + filename;
            File downLoadFile = new File(realPath);
            FileInputStream fis = null;
            try {
                fis = new FileInputStream(downLoadFile);
            } catch (FileNotFoundException ex) {
                log("Error downloading file=" + ex.getMessage());
                error("Error downloading file=" + ex.getMessage());
                return null;
            }
            
            FileChannel fc = fis.getChannel();
            byte[] data = null;
            try {
                data = new byte[new Long(fc.size()).intValue()];
                ByteBuffer bb = ByteBuffer.wrap(data);
                fc.read(bb);
                fc.close();
                fis.close();
                
                FacesContext facesContext = FacesContext.getCurrentInstance();
                HttpServletResponse response = (HttpServletResponse)facesContext.getExternalContext().getResponse();
                response.setHeader("Content-disposition", "attachment; filename=" + filename);
                response.setContentLength(data.length);
                response.setContentType(contentType);
                ServletOutputStream out = response.getOutputStream();
                out.write(data);
                
                facesContext.responseComplete();
            } catch (IOException ex) {
                log("Error downloading file=" + ex.getMessage());
                error("Error downloading file=" + ex.getMessage());
                return null;
            }
            
            
            /**
             * Now record the fact that this plugin was downloaded.
             */
            
            Plugin currentPlugin = getSessionBean1().getCurrentPlugin();
            try {
                getApplicationBean1().getPluginSystem().incrementPluginDownloads(currentPlugin);
            } catch (PluginException ex) {
                log("Error counting download=" + ex.getMessage());
                error("Error counting download=" + ex.getMessage());
                return null;
            }
        }
        /**
         *
         * We return non-null to force a page refresh so we can show the downloads incremented.
         *
         */
        
        return "detail";
    }
    
    public String category_action() {
        return "category";
    }
    
    public void category_action(ActionEvent ae) {
        
        ActionEvent action = ae;
        String currentCategoryName = ((Hyperlink)ae.getComponent()).getType();
        getSessionBean1().setCurrentCategoryName(currentCategoryName);
        return;
    }
    
    /**
     * Holds value of property sizeConverter.
     */
    private SizeConverter sizeConverter = new SizeConverter();
    
    /**
     * Getter for property sizeConverter.
     * @return Value of property sizeConverter.
     */
    public SizeConverter getSizeConverter() {
        return this.sizeConverter;
    }
    
    /**
     * Setter for property sizeConverter.
     * @param sizeConverter New value of property sizeConverter.
     */
    public void setSizeConverter(SizeConverter sizeConverter) {
        this.sizeConverter = sizeConverter;
    }
    
    public String btnUpdate_action() {
        if(null == getRequestBean1() || null == getSessionBean1() || null == getSessionBean1().getCurrentPlugin()) {
            return null;
        }
        getRequestBean1().setTargetPlatforms(getSessionBean1().getCurrentPlugin().getTarget_platforms());
        getSessionBean1().setReturnFromModifyPage("detail");
        return "modify";
    }
    
    
    
}

