/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.system;

import java.util.Date;

/**
 * This type represents a Plugin comment.
 * @author David Botterill
 */
public interface Comment {
    /**
     * Getter for property comment_summary.
     * 
     * @return Value of property comment_summary.
     */
    String getComment_summary();

    /**
     * Getter for property date_entered.
     * 
     * @return Value of property date_entered.
     */
    Date getDate_entered();

    /**
     * Gets the id of this CommentImpl.
     * 
     * 
     * @return the id
     */
    Long getId();


    /**
     * Getter for property title.
     * 
     * @return Value of property title.
     */
    String getTitle();

    /**
     * Getter for property userid.
     * 
     * @return Value of property userid.
     */
    String getUserid();

    /**
     * Setter for property comment_summary.
     * 
     * @param comment_summary New value of property comment_summary.
     */
    void setComment_summary(String comment_summary);

    /**
     * Setter for property date_entered.
     * 
     * @param date_entered New value of property date_entered.
     */
    void setDate_entered(Date date_entered);

    /**
     * Setter for property title.
     * 
     * @param title New value of property title.
     */
    void setTitle(String title);

    /**
     * Setter for property userid.
     * 
     * @param userid New value of property userid.
     */
    void setUserid(String userid);

    /**
     * Getter for property plugin.
     * @return Value of property plugin.
     */
    public Plugin getPlugin();

    
}
