/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.util.ArrayList;
import javax.swing.JFrame;
import javax.swing.ListModel;
import javax.swing.event.ListDataListener;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.beans.TestCase;
import org.netbeans.testspeceditor.beans.TestSpec;

/**
 *
 * @author  ehucka
 */
public class PackCasesDialog extends javax.swing.JDialog {
    
    TestCase[] cases;
    
    /** Creates new form CasesDialog */
    public PackCasesDialog(TestCase[] cases) {
        super(Application.getInstance().getUi(), false);
        this.cases = cases;
        initComponents();
        JFrame parent=Application.getInstance().getUi();
        int w = 420;
        int h = 350;
        
        if (w > parent.getWidth()) {
            w = parent.getWidth();
        }
        if (h > parent.getHeight()) {
            h = parent.getHeight();
        }
        setSize(w, h);
        setLocation(parent.getX()+(parent.getWidth()-getWidth())/2,
                parent.getY()+(parent.getHeight()-getHeight())/2);
        int[] indices = new int[cases.length];
        for (int i = 0; i < indices.length; i++) {
            indices[i] = i;
        }
        casesList.setSelectedIndices(indices);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        casesList = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        confirmB = new javax.swing.JButton();
        stornoB = new javax.swing.JButton();

        FormListener formListener = new FormListener();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Remove Selected Cases");

        jPanel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 1, 10));
        jPanel1.setLayout(new java.awt.BorderLayout());

        casesList.setModel(new MyModel());
        casesList.setToolTipText("Select Test Cases to add them into the Test Suite.");
        casesList.addMouseListener(formListener);
        jScrollPane1.setViewportView(casesList);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 10));

        confirmB.setText("Remove");
        confirmB.setToolTipText("Remove selected Test Cases");
        confirmB.setMargin(new java.awt.Insets(2, 3, 2, 3));
        confirmB.setPreferredSize(new java.awt.Dimension(64, 21));
        confirmB.addActionListener(formListener);
        jPanel2.add(confirmB);

        stornoB.setText("Close");
        stornoB.setMargin(new java.awt.Insets(2, 3, 2, 3));
        stornoB.setPreferredSize(new java.awt.Dimension(64, 21));
        stornoB.addActionListener(formListener);
        jPanel2.add(stornoB);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener, java.awt.event.MouseListener {
        FormListener() {}
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == confirmB) {
                PackCasesDialog.this.confirmBActionPerformed(evt);
            }
            else if (evt.getSource() == stornoB) {
                PackCasesDialog.this.stornoBActionPerformed(evt);
            }
        }

        public void mouseClicked(java.awt.event.MouseEvent evt) {
            if (evt.getSource() == casesList) {
                PackCasesDialog.this.casesListMouseClicked(evt);
            }
        }

        public void mouseEntered(java.awt.event.MouseEvent evt) {
        }

        public void mouseExited(java.awt.event.MouseEvent evt) {
        }

        public void mousePressed(java.awt.event.MouseEvent evt) {
        }

        public void mouseReleased(java.awt.event.MouseEvent evt) {
        }
    }// </editor-fold>//GEN-END:initComponents
    
private void casesListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_casesListMouseClicked
    if (evt.getClickCount() >= 2 && casesList.getSelectedIndex() > -1) {
        int sel = casesList.getSelectedIndex();
        Application.getInstance().getUi().selectNodeFor(cases[sel]);
    }
}//GEN-LAST:event_casesListMouseClicked

    private void stornoBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stornoBActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                setVisible(false);
                dispose();
            }
        });
    }//GEN-LAST:event_stornoBActionPerformed
    
    private void confirmBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_confirmBActionPerformed
        Object[] objs=casesList.getSelectedValues();
        TestSpec testSpec = Application.getInstance().getDocument().getTestSpec();
        for (Object ob:objs) {
            TestCase cs = (TestCase)ob;
            testSpec.removeTestCase(cs);
        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                setVisible(false);
                dispose();
            }
        });
    }//GEN-LAST:event_confirmBActionPerformed
    
    
    /**
     * @param args the command line arguments
     */
    public void display() {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                setVisible(true);
            }
        });
    }
    
    class MyModel implements ListModel {
        
        ArrayList<ListDataListener> listeners=new ArrayList(4);
        
        public Object getElementAt(int index) {
            return cases[index];
        }
        
        public void removeListDataListener(javax.swing.event.ListDataListener l) {
            listeners.remove(l);
        }
        
        public void addListDataListener(javax.swing.event.ListDataListener l) {
            listeners.add(l);
        }
        
        public int getSize() {
            return cases.length;
        }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JList casesList;
    protected javax.swing.JButton confirmB;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JPanel jPanel2;
    protected javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JButton stornoB;
    // End of variables declaration//GEN-END:variables
    
}
