/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.JTree;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.beans.TestCase;
import org.netbeans.testspeceditor.beans.TestSuite;
import org.netbeans.testspeceditor.events.Bean;
import org.netbeans.testspeceditor.find.FoundOccurance;
import org.netbeans.testspeceditor.find.HighLightingSupport;
import org.netbeans.testspeceditor.find.ReplaceEngine;
import org.netbeans.testspeceditor.find.ReplaceOccurance;
import org.netbeans.testspeceditor.find.ReplacePattern;
import org.netbeans.testspeceditor.ui.status.StatusManager;
import org.netbeans.testspeceditor.ui.tree.CasesNode;
import org.netbeans.testspeceditor.ui.tree.DataNode;
import org.netbeans.testspeceditor.ui.tree.Node;
import org.netbeans.testspeceditor.ui.tree.SuitesNode;
import org.netbeans.testspeceditor.ui.tree.TestSpecNode;
import org.netbeans.testspeceditor.ui.tree.find.FoundBeanNode;
import org.netbeans.testspeceditor.ui.tree.find.FoundOccuranceNode;
import org.netbeans.testspeceditor.ui.tree.find.FoundTreeModel;
import org.netbeans.testspeceditor.ui.tree.find.FoundTreeRenderer;
import org.netbeans.testspeceditor.utils.Utils;

/**
 *
 * @author  ehucka
 */
public class ReplaceDialog extends javax.swing.JDialog {
    
    static LinkedList<String> founds=new LinkedList();
    static LinkedList<String> replaced=new LinkedList();
    
    private FoundTreeModel treeModel;
    
    HistoryComboModel modelFind;
    HistoryComboModel modelReplace;
    
    Node[] selected = null;
    
    ReplaceEngine engine;
    
    /** Creates new form FindDialog */
    public ReplaceDialog(Node[] selected) {
        super(Application.getInstance().getUi(), false);
        modelFind=new HistoryComboModel(founds);
        modelReplace=new HistoryComboModel(replaced);
        this.selected = selected;
        treeModel=new FoundTreeModel();
        initComponents();
        setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,
                getParent().getY()+(getParent().getHeight()-getHeight())/2);
        getRootPane().setDefaultButton(previewB);
    }
    
    public FoundTreeModel getTreeModel() {
        return treeModel;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        findWhatC = new javax.swing.JComboBox();
        previewB = new javax.swing.JButton();
        matchCase = new javax.swing.JCheckBox();
        wholeWord = new javax.swing.JCheckBox();
        reguralExprs = new javax.swing.JCheckBox();
        stornoB = new javax.swing.JButton();
        selectedNodes = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new JTree(getTreeModel());
        jLabel2 = new javax.swing.JLabel();
        packRadio = new javax.swing.JRadioButton();
        expandRadio = new javax.swing.JRadioButton();
        highlight = new javax.swing.JCheckBox();
        replaceAllB = new javax.swing.JButton();
        selectedOnly = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        replaceWithC = new javax.swing.JComboBox();

        setTitle("Replace");
        jLabel1.setDisplayedMnemonic('f');
        jLabel1.setFont(new java.awt.Font("Dialog", 0, 11));
        jLabel1.setLabelFor(findWhatC);
        jLabel1.setText("Find What:");

        findWhatC.setEditable(true);
        findWhatC.setFont(new java.awt.Font("Dialog", 0, 12));
        findWhatC.setModel(modelFind);

        previewB.setFont(new java.awt.Font("Dialog", 0, 12));
        previewB.setMnemonic('v');
        previewB.setText("Preview");
        previewB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        previewB.setPreferredSize(new java.awt.Dimension(80, 24));
        previewB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previewBActionPerformed(evt);
            }
        });

        matchCase.setFont(new java.awt.Font("Dialog", 0, 11));
        matchCase.setMnemonic('m');
        matchCase.setText("Match Case");
        matchCase.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        matchCase.setMargin(new java.awt.Insets(0, 0, 0, 0));

        wholeWord.setFont(new java.awt.Font("Dialog", 0, 11));
        wholeWord.setMnemonic('w');
        wholeWord.setText("Whole Word");
        wholeWord.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        wholeWord.setMargin(new java.awt.Insets(0, 0, 0, 0));

        reguralExprs.setFont(new java.awt.Font("Dialog", 0, 11));
        reguralExprs.setMnemonic('x');
        reguralExprs.setText("Regural Expressions");
        reguralExprs.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        reguralExprs.setMargin(new java.awt.Insets(0, 0, 0, 0));
        reguralExprs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reguralExprsActionPerformed(evt);
            }
        });

        stornoB.setFont(new java.awt.Font("Dialog", 0, 12));
        stornoB.setText("Close");
        stornoB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        stornoB.setPreferredSize(new java.awt.Dimension(80, 24));
        stornoB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stornoBActionPerformed(evt);
            }
        });

        selectedNodes.setFont(new java.awt.Font("Dialog", 0, 11));
        selectedNodes.setMnemonic('n');
        selectedNodes.setText("Find in Selected Nodes");
        selectedNodes.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        selectedNodes.setMargin(new java.awt.Insets(0, 0, 0, 0));

        tree.setCellRenderer(new FoundTreeRenderer());
        tree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                treeMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(tree);

        jLabel2.setDisplayedMnemonic('o');
        jLabel2.setFont(new java.awt.Font("Dialog", 0, 11));
        jLabel2.setText("Found Occurances:");

        buttonGroup1.add(packRadio);
        packRadio.setFont(new java.awt.Font("Dialog", 0, 10));
        packRadio.setMnemonic('p');
        packRadio.setSelected(true);
        packRadio.setText("Pack");
        packRadio.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        packRadio.setMargin(new java.awt.Insets(0, 0, 0, 0));
        packRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                packRadioActionPerformed(evt);
            }
        });

        buttonGroup1.add(expandRadio);
        expandRadio.setFont(new java.awt.Font("Dialog", 0, 10));
        expandRadio.setMnemonic('e');
        expandRadio.setText("Expand All");
        expandRadio.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        expandRadio.setMargin(new java.awt.Insets(0, 0, 0, 0));
        expandRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expandRadioActionPerformed(evt);
            }
        });

        highlight.setFont(new java.awt.Font("Dialog", 0, 11));
        highlight.setMnemonic('h');
        highlight.setSelected(true);
        highlight.setText("HighLight Occurances");
        highlight.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        highlight.setMargin(new java.awt.Insets(0, 0, 0, 0));

        replaceAllB.setFont(new java.awt.Font("Dialog", 0, 12));
        replaceAllB.setMnemonic('r');
        replaceAllB.setText("Replace");
        replaceAllB.setEnabled(false);
        replaceAllB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        replaceAllB.setPreferredSize(new java.awt.Dimension(80, 24));
        replaceAllB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                replaceAllBActionPerformed(evt);
            }
        });

        selectedOnly.setFont(new java.awt.Font("Dialog", 0, 11));
        selectedOnly.setMnemonic('c');
        selectedOnly.setText("Replace Selected Occurances Only");
        selectedOnly.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        selectedOnly.setEnabled(false);
        selectedOnly.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jLabel3.setDisplayedMnemonic('f');
        jLabel3.setFont(new java.awt.Font("Dialog", 0, 11));
        jLabel3.setLabelFor(replaceWithC);
        jLabel3.setText("Replace With:");

        replaceWithC.setEditable(true);
        replaceWithC.setFont(new java.awt.Font("Dialog", 0, 12));
        replaceWithC.setModel(modelReplace);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 522, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1)
                            .add(jLabel3))
                        .add(3, 3, 3)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(matchCase)
                                    .add(wholeWord)
                                    .add(reguralExprs))
                                .add(17, 17, 17)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(selectedNodes)
                                    .add(selectedOnly))
                                .add(8, 8, 8))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, replaceWithC, 0, 363, Short.MAX_VALUE)
                                    .add(findWhatC, 0, 363, Short.MAX_VALUE))
                                .add(6, 6, 6))
                            .add(layout.createSequentialGroup()
                                .add(highlight)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(previewB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(replaceAllB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(stornoB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(packRadio)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(expandRadio)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(findWhatC, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(previewB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(replaceAllB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel3)
                    .add(replaceWithC, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(matchCase)
                            .add(selectedNodes))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(wholeWord)
                            .add(selectedOnly)))
                    .add(stornoB, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(reguralExprs)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(highlight)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(packRadio)
                    .add(expandRadio))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void replaceAllBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_replaceAllBActionPerformed
        try {
            StatusManager.getInstance().setWaitCursor(true);
            if (selectedOnly.isSelected()) {
                Node[] nodes=Utils.getSelectedNodes(tree);
                ArrayList<ReplaceOccurance> occurs=new ArrayList(12);
                if (nodes != null) {
                    for (int i = 0; i < nodes.length; i++) {
                        Node bn;
                        if (nodes[i] instanceof FoundBeanNode) {
                            FoundOccurance[] ocs=((FoundBeanNode)nodes[i]).getFoundBean().getOccurances();
                            for (int j = 0; j < ocs.length; j++) {
                                occurs.add((ReplaceOccurance)ocs[j]);
                            }
                        } else {
                            occurs.add((ReplaceOccurance)((FoundOccuranceNode)nodes[i]).getOccurance());
                        }
                    }
                }
                engine.replace(occurs.toArray(new ReplaceOccurance[occurs.size()]));
            } else {
                engine.replace();
            }
        } finally {
            StatusManager.getInstance().setWaitCursor(false);
        }
    }//GEN-LAST:event_replaceAllBActionPerformed
    
    private void expandRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_expandRadioActionPerformed
        for (int i = 0; i < tree.getRowCount(); i++) {
            tree.expandRow(i);
        }
    }//GEN-LAST:event_expandRadioActionPerformed
    
    private void packRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_packRadioActionPerformed
        for (int i = 1; i < tree.getRowCount(); i++) { //not the first root node
            tree.collapseRow(i);
        }
    }//GEN-LAST:event_packRadioActionPerformed
    
    private void treeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_treeMouseClicked
        if (evt.getClickCount() >= 2 && tree.getSelectionPath() != null) {
            Node n=(Node)(tree.getSelectionPath().getLastPathComponent());
            if (n != null) {
                FoundBeanNode bn;
                if (n instanceof FoundBeanNode)
                    bn=(FoundBeanNode)n;
                else
                    bn=(FoundBeanNode)(n.getParent());
                if (bn != null)
                    Application.getInstance().getUi().selectNodeFor(bn.getFoundBean());
            }
        }
    }//GEN-LAST:event_treeMouseClicked
    
    private void reguralExprsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reguralExprsActionPerformed
        if (reguralExprs.isSelected()) {
            wholeWord.setEnabled(false);
        } else {
            wholeWord.setEnabled(true);
        }
    }//GEN-LAST:event_reguralExprsActionPerformed
    
    private void stornoBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stornoBActionPerformed
        setVisible(false);
    }//GEN-LAST:event_stornoBActionPerformed
    
    private void previewBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previewBActionPerformed
        try {
            StatusManager.getInstance().setWaitCursor(true);
            String pat=(String)findWhatC.getSelectedItem();
            String rep=(String)replaceWithC.getSelectedItem();
            ReplacePattern pattern=new ReplacePattern(pat, matchCase.isSelected(),
                    wholeWord.isSelected(), reguralExprs.isSelected(), selectedNodes.isSelected(), rep);
            engine=new ReplaceEngine(pattern);
            
            if (selectedNodes.isSelected()) {
                selected=Utils.getSelectedNodes(Application.getInstance().getUi().getTree());
                if (selected != null) {
                    Node[] nodes=Utils.getSelectedNodesOneInPath(selected);
                    for (int i = 0; i < nodes.length; i++) {
                        if (nodes[i] instanceof TestSpecNode) {
                            engine.find(((TestSpecNode)nodes[i]).getTestSpec(), null, -1);
                            break;
                        } else if (nodes[i] instanceof SuitesNode) {
                            TestSuite[] ts=Application.getInstance().getDocument().getTestSpec().getTestSuites();
                            for (int j = 0; j < ts.length; j++) {
                                engine.find(ts[j], null, -1);
                            }
                        } else if (nodes[i] instanceof CasesNode) {
                            TestCase[] tc=Application.getInstance().getDocument().getTestSpec().getTestCases();
                            for (int j = 0; j < tc.length; j++) {
                                engine.find(tc[j], null, -1);
                            }
                        } else {
                            Node par=(Node)nodes[i].getParent();
                            engine.find((Bean)((DataNode)nodes[i]).getData(), (par instanceof DataNode)?
                                (Bean)((DataNode)par).getData():null, (par instanceof DataNode)?
                                    par.getIndex(nodes[i]):-1);
                        }
                    }
                }
            } else {
                engine.find();
            }
            if (highlight.isSelected()) {
                HighLightingSupport.getInstance().setPattern(pattern);
            }
            HighLightingSupport.getInstance().setHighlight(highlight.isSelected());
            
            getTreeModel().setRoot(engine.getFoundData());
            if (!founds.contains(pat)) {
                founds.addFirst(pat);
                modelFind.fireEventAddFirst();
            } else {
                int ind=founds.indexOf(pat);
                founds.remove(ind);
                modelFind.fireEventRemove(ind);
                founds.addFirst(pat);
                modelFind.fireEventAddFirst();
            }
            if (!replaced.contains(rep)) {
                founds.addFirst(pat);
                modelReplace.fireEventAddFirst();
            } else {
                int ind=founds.indexOf(rep);
                replaced.remove(rep);
                modelReplace.fireEventRemove(ind);
                replaced.addFirst(rep);
                modelReplace.fireEventAddFirst();
            }
            if (engine.getFoundData().getOccurances() > 0) {
                replaceAllB.setEnabled(true);
                selectedOnly.setEnabled(true);
            } else {
                replaceAllB.setEnabled(false);
                selectedOnly.setEnabled(false);
            }
        } finally {
            StatusManager.getInstance().setWaitCursor(false);
        }
    }//GEN-LAST:event_previewBActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton expandRadio;
    private javax.swing.JComboBox findWhatC;
    private javax.swing.JCheckBox highlight;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox matchCase;
    private javax.swing.JRadioButton packRadio;
    private javax.swing.JButton previewB;
    private javax.swing.JCheckBox reguralExprs;
    private javax.swing.JButton replaceAllB;
    private javax.swing.JComboBox replaceWithC;
    private javax.swing.JCheckBox selectedNodes;
    private javax.swing.JCheckBox selectedOnly;
    private javax.swing.JButton stornoB;
    private javax.swing.JTree tree;
    private javax.swing.JCheckBox wholeWord;
    // End of variables declaration//GEN-END:variables
    
}
