/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.panels;

import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.beans.TestAction;
import org.netbeans.testspeceditor.beans.TestCase;
import org.netbeans.testspeceditor.events.Bean;
import org.netbeans.testspeceditor.options.Options;
import org.netbeans.testspeceditor.ui.edits.HTMLEditor;
import org.netbeans.testspeceditor.ui.edits.TextAdapter;
/**
 *
 * @author  ehucka
 */
public class ActionPanel extends AbstractPanel {
    
    /** Creates new form ActionPanel */
    public ActionPanel() {
        initComponents();
        initAdapters();
        setValues();
        jSplitPane1.setDividerLocation((int)(Options.getInstance().getDividerLocations().getAction1()*Application.getInstance().getUi().getHeight()));
        jSplitPane2.setDividerLocation((int)(Options.getInstance().getDividerLocations().getAction2()*Application.getInstance().getUi().getHeight()));
    }
    
    public void setBean(Bean bean, Bean parent) {
        super.setBean(bean, parent);
        if (bean == null || parent == null) {
            previousEditor.setText("");
            nextEditor.setText("");
        } else {
            TestCase testCase=(TestCase)parent;
            TestAction[] acts=testCase.getActions();
            for (int i = 0; i < acts.length; i++) {
                if (acts[i] == bean) {
                    if (i-1 >= 0) {
                        previousEditor.setText(acts[i-1].getContent());
                    } else {
                        previousEditor.setText("");
                    }
                    if (i+1 < acts.length) {
                        nextEditor.setText(acts[i+1].getContent());
                    } else {
                        nextEditor.setText("");
                    }
                }
            }
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        previousEditor = new HTMLEditor();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        actionEditor = new HTMLEditor();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        nextEditor = new HTMLEditor();

        jSplitPane1.setBorder(null);
        jSplitPane1.setDividerSize(7);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(0.2);
        jSplitPane1.setOneTouchExpandable(true);
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Previous Action:"));
        previousEditor.setBackground(new java.awt.Color(235, 235, 235));
        previousEditor.setEditable(false);
        previousEditor.setForeground(new java.awt.Color(42, 42, 42));
        jScrollPane3.setViewportView(previousEditor);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane3)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 37, Short.MAX_VALUE)
        );
        jSplitPane1.setLeftComponent(jPanel1);

        jSplitPane2.setBorder(null);
        jSplitPane2.setDividerSize(7);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setResizeWeight(0.75);
        jSplitPane2.setOneTouchExpandable(true);
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Action:"));
        jScrollPane1.setViewportView(actionEditor);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
        );
        jSplitPane2.setLeftComponent(jPanel2);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Next Action:"));
        nextEditor.setBackground(new java.awt.Color(235, 235, 235));
        nextEditor.setEditable(false);
        nextEditor.setForeground(new java.awt.Color(42, 42, 42));
        jScrollPane2.setViewportView(nextEditor);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
        );
        jSplitPane2.setRightComponent(jPanel3);

        jSplitPane1.setRightComponent(jSplitPane2);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 247, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    protected void initAdapters() {
        try {
            adapters.add(new TextAdapter(actionEditor, TestAction.class, "content"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void finish() {
        if (jSplitPane1.getDividerLocation() > -1 ) {
            Options.getInstance().getDividerLocations().setAction1(jSplitPane1.getDividerLocation()*1.0/Application.getInstance().getUi().getHeight());
            Options.getInstance().getDividerLocations().setAction2(jSplitPane2.getDividerLocation()*1.0/Application.getInstance().getUi().getHeight());
        }
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JEditorPane actionEditor;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JPanel jPanel2;
    protected javax.swing.JPanel jPanel3;
    protected javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JScrollPane jScrollPane2;
    protected javax.swing.JScrollPane jScrollPane3;
    protected javax.swing.JSplitPane jSplitPane1;
    protected javax.swing.JSplitPane jSplitPane2;
    protected javax.swing.JEditorPane nextEditor;
    protected javax.swing.JEditorPane previousEditor;
    // End of variables declaration//GEN-END:variables
    
}
