/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.panels;

import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.beans.TestSuite;
import org.netbeans.testspeceditor.options.Options;
import org.netbeans.testspeceditor.ui.edits.HTMLEditor;
import org.netbeans.testspeceditor.ui.edits.TextAdapter;
/**
 *
 * @author  ehucka
 */
public class SuitePanel extends AbstractPanel {
    
    /** Creates new form SuitePanel */
    public SuitePanel() {
        initComponents();
        initAdapters();
        setValues();
        jSplitPane1.setDividerLocation((int)(Options.getInstance().getDividerLocations().getSuite1()*Application.getInstance().getUi().getHeight()));
        jSplitPane2.setDividerLocation((int)(Options.getInstance().getDividerLocations().getSuite2()*Application.getInstance().getUi().getHeight()));
        jSplitPane3.setDividerLocation((int)(Options.getInstance().getDividerLocations().getSuite3()*Application.getInstance().getUi().getHeight()));
    }
    
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        suiteTitleF = new javax.swing.JTextField();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        setupEditor = new HTMLEditor();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        purposeEditor = new HTMLEditor();
        jSplitPane3 = new javax.swing.JSplitPane();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        teardownEditor = new HTMLEditor();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        commentEditor = new HTMLEditor();

        jLabel1.setText("Title:");

        suiteTitleF.setColumns(36);
        suiteTitleF.setFont(new java.awt.Font("Dialog", 1, 12));
        suiteTitleF.setForeground(new java.awt.Color(0, 0, 0));

        jSplitPane1.setBorder(null);
        jSplitPane1.setDividerSize(4);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(0.25);
        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Setup:"));
        jScrollPane1.setViewportView(setupEditor);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 53, Short.MAX_VALUE)
        );
        jSplitPane1.setTopComponent(jPanel6);

        jSplitPane2.setBorder(null);
        jSplitPane2.setDividerSize(4);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setResizeWeight(0.333);
        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Purpose:"));
        jScrollPane2.setViewportView(purposeEditor);

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 62, Short.MAX_VALUE)
        );
        jSplitPane2.setTopComponent(jPanel4);

        jSplitPane3.setBorder(null);
        jSplitPane3.setDividerSize(4);
        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane3.setResizeWeight(0.5);
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Teardown:"));
        jScrollPane3.setViewportView(teardownEditor);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 57, Short.MAX_VALUE)
        );
        jSplitPane3.setTopComponent(jPanel2);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Comment:"));
        jScrollPane4.setViewportView(commentEditor);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
        );
        jSplitPane3.setBottomComponent(jPanel3);

        jSplitPane2.setBottomComponent(jSplitPane3);

        jSplitPane1.setBottomComponent(jSplitPane2);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, suiteTitleF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(suiteTitleF, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(8, 8, 8)
                .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                .addContainerGap())
        );
    }
    // </editor-fold>//GEN-END:initComponents
    
    protected void initAdapters() {
        try {
            adapters.add(new TextAdapter(suiteTitleF, TestSuite.class, "title"));
            adapters.add(new TextAdapter(commentEditor, TestSuite.class, "comments"));
            adapters.add(new TextAdapter(purposeEditor, TestSuite.class, "purpose"));
            adapters.add(new TextAdapter(teardownEditor, TestSuite.class, "teardown"));
            adapters.add(new TextAdapter(setupEditor, TestSuite.class, "setup"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void finish() {
        if (jSplitPane1.getDividerLocation() > -1) {
            Options.getInstance().getDividerLocations().setSuite1(jSplitPane1.getDividerLocation()*1.0/Application.getInstance().getUi().getHeight());
            Options.getInstance().getDividerLocations().setSuite2(jSplitPane2.getDividerLocation()*1.0/Application.getInstance().getUi().getHeight());
            Options.getInstance().getDividerLocations().setSuite3(jSplitPane3.getDividerLocation()*1.0/Application.getInstance().getUi().getHeight());
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JEditorPane commentEditor;
    protected javax.swing.JLabel jLabel1;
    protected javax.swing.JPanel jPanel2;
    protected javax.swing.JPanel jPanel3;
    protected javax.swing.JPanel jPanel4;
    protected javax.swing.JPanel jPanel6;
    protected javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JScrollPane jScrollPane2;
    protected javax.swing.JScrollPane jScrollPane3;
    protected javax.swing.JScrollPane jScrollPane4;
    protected javax.swing.JSplitPane jSplitPane1;
    protected javax.swing.JSplitPane jSplitPane2;
    protected javax.swing.JSplitPane jSplitPane3;
    protected javax.swing.JEditorPane purposeEditor;
    protected javax.swing.JEditorPane setupEditor;
    protected javax.swing.JTextField suiteTitleF;
    protected javax.swing.JEditorPane teardownEditor;
    // End of variables declaration//GEN-END:variables
    
}
