/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted;

import java.util.Hashtable;

/**
 *
 * @author  Petr Slegr
 * @version 10.05.02
 */
public class GeometryFactoryRegistry {
    
    private static Hashtable factories = new Hashtable ();
    
    public static GeometryFactory getFactory (Class clazz) {
        return (GeometryFactory) factories.get (clazz);
    }

    /** Sets factory for specified class.
     * @param clazz must be class object of subclass of VisualAutomatonElement
     */
    public static void setFactory (Class clazz, GeometryFactory factory) {
        if (! VisualAutomatonElement.class.isAssignableFrom (clazz)) {
            throw new IllegalArgumentException ("clazz must be subclass of VisualAutomatonElement: " 
            + clazz);
        }
        Object o = factories.put (clazz, factory);
        if (o != null) {
            AutomatonEditorPanel panel = MainManager.getDefault ().getCurrentPanel ();
            if (panel != null) {
                panel.repaint ();
            }
        }
    }

}
