/*
                    Sun Public License Notice
 
The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/
 
The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.
 
Contributor(s): Petr Slegr.
 */

package org.netbeans.modules.regsup.auted.actions;

import javax.swing.*;
import org.openide.util.actions.CallableSystemAction;
import org.openide.util.HelpCtx;
import org.netbeans.modules.regsup.auted.*;
import java.awt.Point;
import org.openide.util.NbBundle;
import org.netbeans.modules.regsup.util.Util;
import java.util.*;

/**
 *
 * @author  Petr Slegr
 * @version 16.9.01
 */
public class DeleteAction extends ElementAction {
    
    public void performAction (VisualAutomatonElement[] selected) {
        VisualAutomatonContainer container = null;
        List nodes = new ArrayList ();
        List edges = new ArrayList ();
        for (int i = 0; i < selected.length; i++) {
            if (selected[i] instanceof VisualAutomatonEdge) {
                edges.add (selected[i]);
            }
            else if (selected[i] instanceof VisualAutomatonNode) {
                nodes.add (selected[i]);
            }
        }
        //
        for (Iterator it = nodes.iterator (); it.hasNext (); ) {
            edges.removeAll (((VisualAutomatonNode) it.next ()).getEdges ());
        }
        List toDelete = nodes;
        toDelete.addAll (edges);
        // calculates that all elements need not be from the same container
        for (Iterator it = toDelete.iterator (); it.hasNext (); ) {
            VisualAutomatonElement element = (VisualAutomatonElement) it.next ();
            container = element.getContainer ();
            container.removeElement (element);
        }
    }
    
    public String getName () {
        return NbBundle.getMessage (DeleteAction.class, "CTL_DELETE_ACTION");
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        boolean b1 = selected.length > 0;
        boolean b2 = ! Util.containsTopLevelContainer (selected);
        return b1 && b2;
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
