/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.debug;

import org.netbeans.modules.regsup.auted.*;

/**
 *
 * @author  Petr Slegr
 * @version 28.12.01
 */
public class EdgeBreakpoint extends AutomatonBreakpoint {
    
    protected VisualAutomatonEdge edge;

    /** Creates new EdgeBreakpoint */
    public EdgeBreakpoint (VisualAutomatonEdge edge) {
        this.edge = edge;
    }

    public boolean applies (RexDebuggerState last) {
        return last.getEdges ().contains (edge);
    }
    
    /** Return element of automaton this breakpoint is on or null (e.g. for
     * some more complicated multi-element breakpoints).
     */
    public VisualAutomatonElement getElement () {
        return edge;
    }
    
}
