/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.debug;

import org.netbeans.modules.regsup.auted.VisualAutomatonContainer;

/**
 *
 * @author  Petr Slegr
 * @version 01.04.02
 */
public interface RexDebuggerListener extends java.util.EventListener {

    /** Invoked when input has been read and a final state has been reached
     */
    public void inputAccepted (RexDebuggerEvent e);
    
    /** Invoked when input has not been completely read but next move it is not
     * possible.
     */
    public void hanged (RexDebuggerEvent e);
    
    /** Invoked when SUSPEND breakpoint is applied
     */
    public void suspended (RexDebuggerEvent e);
    
    /* Invoked when any breakpoint is applied.
     */
    public void breakpointApplied (RexDebuggerEvent e);
    
    /** Invoked after debugger has started and is ready.
     */
    public void started (RexDebuggerEvent e);

    /**
     */
    public void characterReaded (RexDebuggerEvent e);
    
    /**
     */
    public void characterUnReaded (RexDebuggerEvent e);
    
    /**
     */
    public void stageChanged (RexDebuggerEvent e);
    
    /** Invoked when container is found between next nodes
     */
    public void containerReached (VisualAutomatonContainer container, RexDebuggerEvent event);
    
    public void containerStepedIn (VisualAutomatonContainer container, RexDebuggerEvent event);
    
    public void containerStepedOut (VisualAutomatonContainer container, RexDebuggerEvent event);
}
