/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

import org.netbeans.modules.regsup.logic.aut2expr.ResolveResult;

/**
 *
 * @author  Petr Slegr
 * @version 28.11.01
 */
public class CompoundLogicAutomatonNode extends LogicAutomatonNode {

    private LogicAutomaton automaton;
    
    /** Creates new CompoundLogicAutomatonNode */
    public CompoundLogicAutomatonNode (RexElement innnerElement) {
        this (null, innnerElement);
    }
    
    public CompoundLogicAutomatonNode (LogicAutomaton automaton) {
        this (automaton, null);
    }
    
    CompoundLogicAutomatonNode (LogicAutomaton automaton, RexElement innnerElement) {
        // !!! should check whether the both params are consistent
        // !!! oba params by nemely byt null!!!
        super ();
        boolean firstNull = false;
        if (null == automaton) {
            this.automaton = new LogicAutomaton ();
            firstNull = true;
        } else {
            this.automaton = automaton;
        }
        if (null == innnerElement) {
            if (firstNull) {
                throw new IllegalArgumentException ("both arguments cannot be null");
            }
        } else {
            this.innnerElement = innnerElement;
        }
        //included = false; // !!!! na nic
    }
    
    public LogicAutomaton getAutomaton () {
        return automaton;
    }
    
    public boolean isResolved () {
        // !!!! ? checkovat jestli je vyraz ok?
        return innnerElement != null ? true : false;
    }
    
    public ResolveResult resolve () {
        if (isResolved ()) {
            return new ResolveResult (innnerElement);
        } else {
            ResolveResult res = automaton.resolve ();
            if (! res.isOk ()) {
                //res = new ProxyError (this, res);
            } else {
                innnerElement = res.getExpression ();
            }
            return res;
        }
    }
    
    public void clearResolved () {
        innnerElement = null;
    }
    
    public String toString () {
        return super.toString () + " (" + innnerElement + ")";
    }
    
    /** 
    * @param args the command line arguments
    */
    public static void main (String args[]) {
    }

}
