/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic.aut2expr;

import org.netbeans.modules.regsup.logic.*;

/**
 *
 * @author  Petr Slegr
 * @version 02.12.01 
 */
public class LocalResolveError extends DirectResolveError {

    LogicAutomatonNode cause;
   
    /** Creates new ResolveResult */
    public LocalResolveError (String errorName, LogicAutomatonNode cause) {
        super (errorName);
        this.cause = cause;
    }
    
    public LogicAutomatonNode getLocalCause () {
        return cause;
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
    }

    public static class IsolatedNode extends LocalResolveError {
        public IsolatedNode (LogicAutomatonNode cause) {
            super ("Isolated node", cause);
        }
    }

    public static class BadNode extends LocalResolveError {
        public BadNode (LogicAutomatonNode cause) {
            super ("Bad node", cause);
        }
    }

    public static class NonDeterminNode extends LocalResolveError {
        public NonDeterminNode (LogicAutomatonNode cause) {
            super ("Non-deterministic node", cause);
        }
    }
    
}
